% askisi_01.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 1: ΓΕΓΟΝΟΤΑ ΚΑΙ ΕΡΩΤΗΣΕΙΣ ΣΤΗ ΓΛΩΣΣΑ PROLOG
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

man(peter).
man(jimmy).
woman(helen).

/*
?- man(peter).
true

?- woman(helen).
true

?- \+ man(peter).
false

?- \+ woman(peter).
true

?- \+ woman(jenny).
true

?- \+ man(jenny).
true

?- man(peter), man(jimmy).
true

?- man(peter), \+ man(jimmy).
false

?- man(peter); \+ man(jimmy).
true ;
false

?- man(X).
X = peter ;
X = jimmy

?- man(X).
X = peter .

?- man(X).
X = peter ;
X = jimmy

?- man(X); woman(X).
X = peter
X = jimmy
X = helen

?- woman(X); man(X).
X = helen
X = peter
X = jimmy

?- man(X), \+ woman(X).
X = peter
X = jimmy
false

?- \+ woman(X), man(X).
false

?- \+ woman(X).
false

?- man(X), \+ woman(X).
X = peter
X = jimmy

?- \+ woman(X), man(X).
false

?- \+ woman(X); man(X).
X = peter
X = jimmy

?- \+ \+ woman(helen).
true

?- woman(helen).
true

?- woman(X).
X = helen

?- \+ \+ woman(X).
true
*/

mother_of(helen,peter).
mother_of(helen,jimmy).
mother_of(jenny,george).

/*
?- mother_of(helen,peter).
true

?- mother_of(helen,X).
X = peter
X = jimmy

?- mother_of(X,peter).
X = helen

?- mother_of(X,Y).
X = helen,
Y = peter
X = helen,
Y = jimmy
X = jenny,
Y = george

?- mother_of(X,X).
false

?- mother_of(X,_).
X = helen
X = helen
X = jenny

?- mother_of(_,_).
true

?- mother_of(_).
false

?- mother_of(X,Y1), mother_of(X,Y2).
X = helen,
Y1 = Y2, Y2 = peter
X = helen,
Y1 = peter,
Y2 = jimmy
X = helen,
Y1 = jimmy,
Y2 = peter
X = helen,
Y1 = Y2, Y2 = jimmy
X = jenny,
Y1 = Y2, Y2 = george

?- mother_of(X,Y1), mother_of(X,Y2), \+ Y1==Y2.
X = helen,
Y1 = peter,
Y2 = jimmy
X = helen,
Y1 = jimmy,
Y2 = peter
false

?- mother_of(_,Y1), mother_of(_,Y2), \+ Y1==Y2.
Y1 = peter,
Y2 = jimmy
Y1 = peter,
Y2 = george
Y1 = jimmy,
Y2 = peter
Y1 = jimmy,
Y2 = george
Y1 = george,
Y2 = peter
Y1 = george,
Y2 = jimmy
false

?- mother_of(_X,Y1), mother_of(_X,Y2), \+ Y1==Y2.
Y1 = peter,
Y2 = jimmy
Y1 = jimmy,
Y2 = peter
false

?- mother_of(_X,Y1), mother_of(_X,Y2), Y1@<Y2.
Y1 = jimmy,
Y2 = peter
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

father_of(george,bill).
father_of(george,bob).
father_of(bill,jimmy).

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

/*
?- father_of(george,Child).

Child = bill
Child = bob
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

/*
?- father_of(george,X), father_of(X,Grandchild).

Grandchild = jimmy,
X = bill
false


?- father_of(george,_X), father_of(_X,Grandchild).

Grandchild = jimmy
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

/*
?- father_of(Father,bob).

Father = george
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

/*
?- father_of(X,jimmy), father_of(Grandfather,X).

Grandfather = george,
X = bill


?- father_of(_X,jimmy), father_of(Grandfather,_X).

Grandfather = george
*/
