% askisi_02.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 2: ΣΥΝΘΕΤΕΣ ΕΡΩΤΗΣΕΙΣ ΚΑΙ ΚΑΝΟΝΕΣ
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

/*
mother_of(helen,peter).
mother_of(helen,jimmy).
mother_of(jenny,george).

brothers(X,Y):- mother_of(Z,X), mother_of(Z,Y), \+ X==Y.
brothers2:- brothers(X,Y).
brothers3:- brothers(X,Y), write(X), nl, write(Y), nl.
brothers4:- brothers3.

?- brothers(X,Y).
X = peter,
Y = jimmy
X = jimmy,
Y = peter
false

?- mother_of(Z,X), mother_of(Z,Y), \+ X==Y.
Z = helen,
X = peter,
Y = jimmy
Z = helen,
X = jimmy,
Y = peter
false

?- brothers2.
true

?- brothers2(X,Y).
false

?- brothers3.
peter
jimmy
true

?- brothers4.
peter
jimmy
true

man(peter).
man(jimmy).
    :
    :
woman(helen).
woman(jenny).
    :
    :
parent_of(peter,jenny).
parent_of(helen,peter).
    :
    :

father_of(X,Y):- parent_of(X,Y), man(X).
mother_of(X,Y):- parent_of(X,Y), woman(X).

son_of(X,Y):- parent_of(Y,X), man(X).
daughter_of(X,Y):- parent_of(Y,X), woman(X).

grandfather_of(X,Y):- parent_of(X,Z), parent_of(Z,Y), man(X).
grandmother_of(X,Y):- mother_of(X,Z), parent_of(Z,Y).

brother_of(X,Y):- parent_of(Z,X), parent_of(Z,Y), \+ X==Y, man(X).
sister_of(X,Y):- daughter_of(X,Z), parent_of(Z,Y), \+ X==Y.

uncle_of(X,Y):- parent_of(Z,Y), brother_of(X,Z).
aunt_of(X,Y):- sister_of(X,Z), (father_of(Z,Y); mother_of(Z,Y)).
*/

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

link(a,z,75).  link(a,s,140). link(a,t,118). link(z,o,71).  link(o,s,151).
link(t,l,111). link(l,m,70).  link(m,d,75).  link(d,c,120). link(c,r,146).
link(c,p,138). link(s,r,80).  link(r,p,97).  link(p,b,101). link(s,f,99).
link(f,b,211). link(b,g,90).  link(u,h,98).  link(h,e,86).  link(u,v,142).
link(v,i,92).  link(n,i,87).

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

/*
% (α)
?- link(s,X,_); link(X,s,_).
X = r
X = f
X = a
X = o

% (β)
?- (link(s,X,D); link(X,s,D)), D<100.
D = 80,
X = r
D = 99,
X = f
false

% (γ)
?- (link(a,X,_); link(X,a,_)), (link(o,X,_); link(X,o,_)).     % AND
X = z
X = s
false

?- (link(a,X,_); link(X,a,_)); (link(o,X,_); link(X,o,_)).     % OR
X = z
X = s
X = t
X = s
X = z

?- ((link(a,X,_); link(X,a,_)); (link(o,X,_); link(X,o,_))),
    \+(((link(a,X,_); link(X,a,_)), (link(o,X,_); link(X,o,_)))).     % XOR = (A OR B) AND NOT (A AND B)
X = t
false

?- ((link(a,X,_); link(X,a,_)); (link(o,X,_); link(X,o,_))),     % (A OR B) AND
    \+ ((link(a,X,_); link(X,a,_)), (link(o,X,_); link(X,o,_))).     % NOT (A AND B)
X = t
false

% (δ)
?- (link(p,Stop,_); link(Stop,p,_)), (link(Stop,X,_); link(X,Stop,_)).    % Με έναν ενδιάμεσο σταθμό
Stop = b,
X = g
Stop = b,
X = p
Stop = b,
X = f
Stop = c,
X = r
Stop = c,
X = p
Stop = c,
X = d
Stop = r,
X = p
Stop = r,
X = c
Stop = r,
X = s

?- (link(p,_Stop,_); link(_Stop,p,_)), (link(_Stop,X,_); link(X,_Stop,_)).
X = g
X = p
X = f
X = r
X = p
X = d
X = p
X = c
X = s

?- (link(p,Stop,_); link(Stop,p,_)), (link(Stop,X,_); link(X,Stop,_)), \+ X==p.    % και χωρίς να καταλήξουμε στο p
Stop = b,
X = g
Stop = b,
X = f
Stop = c,
X = r
Stop = c,
X = d
Stop = r,
X = c
Stop = r,
X = s

?- (link(p,Stop,_); link(Stop,p,_)), (link(Stop,X,_); link(X,Stop,_)), \+ X==p, \+(link(X,p,_);link(p,X,_)).    % ...ούτε σε πόλεις που συνδέονται απευθείας με το p.
Stop = b,
X = g
Stop = b,
X = f
Stop = c,
X = d
Stop = r,
X = s

% (ε)
% Α' τρόπος:
?- (link(X,Y1,_);link(Y1,X,_)), (link(X,Y2,_);link(Y2,X,_)),
    (link(X,Y3,_);link(Y3,X,_)), \+(Y1==Y2;Y2==Y3;Y3==Y1).
X = a,
Y1 = z,
Y2 = s,
Y3 = t
...
X = b,
Y1 = f,
Y2 = p,
Y3 = g
false

% Β' τρόπος: «@<» σημαίνει «αλφαβητικά μικρότερο».
?- (link(X,Y1,_);link(Y1,X,_)), (link(X,Y2,_);link(Y2,X,_)),
    (link(X,Y3,_);link(Y3,X,_)), Y1@<Y2, Y2@<Y3.
X = a,
Y1 = s,
Y2 = t,
Y3 = z
...
X = b,
Y1 = f,
Y2 = g,
Y3 = p
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

% Α' τρόπος:
neighbours(X,Y):- link(X,Y,_); link(Y,X,_).

/*
?‐ neighbours(m,l).
true

?‐ neighbours(a,p).
false
*/

% Β' τρόπος:
neighbours(X,Y):- link(X,Y,_).
neighbours(X,Y):- link(Y,X,_).

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

next(X,Y):- link(X,Y,_).
next(X,Y):- link(Y,X,_).
% Δεν έχει σημασία ποιο όρισμα είναι είσοδος και ποιο έξοδος.
% Είναι ίδια με την neighbours/2.

/*
?‐ next(m,l).
true

? ‐ next(a,p).
false

?- next(a,X).
X = z
X = s
X = t
false

?- next(X,a).
X = z
X = s
X = t
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

travel(X,Y):- next(X,Stop), next(Stop,Y), \+ X==Y, \+ next(X,Y).

/*
?- travel(p,X).
X = g
X = f
X = d
X = s
*/
