% askisi_03.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 3: BACKTRACKING ΚΑΙ MATCHING
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

/*
man(peter).	man(jimmy).	man(george).
woman(helen).	woman(jenny).	woman(mary).
goal0:- man(X).
goal1:- man(X), write(X), nl.
goal2:- man(X), write(X), nl, fail.
goal3:- man(X), write(X), nl, woman(X).
goal4:- man(X), woman(X), write(X), nl.

?- man(X).
X = peter
X = jimmy
X = george
false

?- goal0.
true

?- goal1.
peter
true

?- goal2.
peter
jimmy
george
false

?- goal3.
peter
jimmy
george
false

?- goal4.
false
*/

/*
now(date(wednesday,17,august,2022),time(13,28,30)).

?- now(X,time(Y,28,30)).
X = date(wednesday,17,august,2022)
Y = 13
false

?- now(date(X,17,_,2022),_).
X = wednesday
false

?- now(date(X,17,_,2022),_,_).
false

?- now(date(X,9,_,_),_).
false

?- now(gate(X,17,_,_),_).
false
*/

% ------------------------------------------------------------------------------
% Από προηγούμενη άσκηση:
% ------------------------------------------------------------------------------

link(a,z,75).  link(a,s,140). link(a,t,118). link(z,o,71).  link(o,s,151).
link(t,l,111). link(l,m,70).  link(m,d,75).  link(d,c,120). link(c,r,146).
link(c,p,138). link(s,r,80).  link(r,p,97).  link(p,b,101). link(s,f,99).
link(f,b,211). link(b,g,90).  link(u,h,98).  link(h,e,86).  link(u,v,142).
link(v,i,92).  link(n,i,87).

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

write_pair(X,Y,D):-
    write(X), write(" --- "), write(Y),
    write(" ("), write(D), write(")").

/*
?- write_pair(a,z,75).
a --- z (75)
true

?- X = a, Y = z, D = 75, write((X,Y,D)).
a,z,75
D = 75,
X = a,
Y = z
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

all_links:- link(X,Y,D), write_pair(X,Y,D), nl, fail.

/*
?- all_links.
a --- z (75)
a --- s (140)
a --- t (118)
...
n --- i (187)
false
*/

% Εναλλακτικά
%all_links:- next(X,Y,D), X@<Y, write_pair(X,Y,D), nl, fail.

next(X,Y,D):- link(X,Y,D).
next(X,Y,D):- link(Y,X,D).

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

all_links_less_than(E):- write("LIMIT = "), write(E), nl,
    link(X,Y,D), D<E, write_pair(X,Y,D), nl, fail.

/*
?- all_links_less_than(100).
LIMIT = 100
a --- z (75)
z --- o (71)
l --- m (70)
m --- d (75)
s --- r (80)
r --- p (97)
s --- f (99)
b --- g (90)
u --- h (98)
h --- e (86)
v --- i (92)
n --- i (87)
false
*/

% Εναλλακτικά
/*
all_links_less_than(L):- write("LIMIT = "), write(L), nl,
    next(X,Y,D), D<L, X@<Y, write_pair(X,Y,D), nl, fail.

?- all_links_less_than(100).
LIMIT = 100
a --- z (75)
l --- m (70)
b --- g (90)
o --- z (71)
d --- m (75)
r --- s (80)
p --- r (97)
f --- s (99)
h --- u (98)
e --- h (86)
i --- v (92)
i --- n (87)
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

same_distance:- link(X1,Y1,D), link(X2,Y2,D), \+( (X1=X2, Y1=Y2) ),
    write_pair(X1,Y1,D), write("   "), write_pair(X2,Y2,D), nl, fail.

/*
?- same_distance.
a --- z (75)   m --- d (75)
m --- d (75)   a --- z (75)
false
*/

% Εναλλακτικά
/*
same_distance:- next(X1,Y1,D), X1@<Y1, next(X2,Y2,D), X2@<Y2,
   \+( (X1=X2, Y1=Y2) ), write_pair(X1,Y1,D), write("   "), write_pair(X2,Y2,D),
   nl, fail.

?- same_distance.
a --- z (75)   d --- m (75)
d --- m (75)   a --- z (75)
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

three_cities_route_less_than(L):-
    write("LIMIT = "), write(L), nl,
    next(X,Y,D1), next(Y,Z,D2), \+ X==Z, D is D1+D2, D<L,
    write(X), write(" --> "), write(Y), write(" --> "), write(Z),
    write(" Distance = "), write(D), nl, fail.

/*
?- three_cities_route_less_than(150).
LIMIT = 150
a --> z --> o Distance = 146
l --> m --> d Distance = 145
o --> z --> a Distance = 146
d --> m --> l Distance = 145
false
*/
