% askisi_04.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 4: ΑΝΑΔΡΟΜΗ ΚΑΙ CUT (!)
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

ancestor(X,Y):- parent(X,Y).
ancestor(X,Y):- parent(X,Z), ancestor(Z,Y).

%  Υπολογισμός Παραγοντικού
paragontiko(1,1).
paragontiko(X,Y):-  X2 is X-1,
              paragontiko(X2,Y2),
              Y is Y2*X.
/*
?- paragontiko(4,X).
X = 24 .
*/

%  Ένα ατέρμονο loop στην Prolog
loop:- loop.

%  Ένας μετρητής
count(X):- write(X), nl,
    NewX is X+1,
    count(NewX).

%  Ένας «κακός» μετρητής
badcount1(X):- write(X), nl,
     NewX is X+1,
     badcount1(NewX),
     nl.

%  Άλλος ένας «κακός» μετρητής
badcount2(X):- write(X), nl,
     NewX is X+1,
     badcount2(NewX).
badcount2(X):- X<0,
     write('X is negative'), nl.

%  Ένας εξίσου «κακός» μετρητής
badcount3(X):- write(X), nl,
     NewX is X+1,
     check(NewX),
     badcount3(NewX).
check(Z):- Z>0.
check(Z):- Z<0, write('X is negative'), nl.

/*
parag(X,1):- 1 =:= X.
parag(X,Y):- X2 = X-1, Y = Y2*X, parag(X2,Y2).

paragontiko(X,Y):- parag(X,Y1), Y is Y1.

?- paragontiko(4,X).
X = 24 .

?- parag(4,X).
X = 1 * (4 - 1 - 1) * (4 - 1) * 4 .
*/

man(peter).    man(jimmy).    man(george).
a:- man(X), write(X), nl, fail.
b:- man(X), !, write(X), nl, fail.
c:- man(X), write(X), nl, !, fail.
d:- !, man(X), write(X), nl,  fail.
e:- man(X), write(X), nl, fail, !.

/*
?- a.
peter
jimmy
george
false

?- b.
peter
false

?- c.
peter
false

?- d.
peter
jimmy
george
false

?- e.
peter
jimmy
george
false
*/

my_not(X):- X, !, fail.
my_not(_).

/*
?- my_not(1=2).
true

?- my_not(2=2).
false
*/

f(X,Y):- X<10, !, Y=1.
f(_,2).

/*
?- f(4,Y).
Y = 1

?- f(14,Y).
Y = 2
*/

/*
a:- (b;c), !, fail.
b:- write(b), nl.
c:- write(c), nl.

?- a.
b
false
*/

% ------------------------------------------------------------------------------
% Από προηγούμενη άσκηση:
% ------------------------------------------------------------------------------

link(a,z,75).  link(a,s,140). link(a,t,118). link(z,o,71).  link(o,s,151).
link(t,l,111). link(l,m,70).  link(m,d,75).  link(d,c,120). link(c,r,146).
link(c,p,138). link(s,r,80).  link(r,p,97).  link(p,b,101). link(s,f,99).
link(f,b,211). link(b,g,90).  link(u,h,98).  link(h,e,86).  link(u,v,142).
link(v,i,92).  link(n,i,87).

next(X,Y):- link(X,Y,_).
next(X,Y):- link(Y,X,_).

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

sum(N,0):- N<0, !.
sum(0,0):- !.
sum(N,Sum):- N1 is N-1, sum(N1,S1), Sum is S1+N.

/*
?- sum(3,S).
S = 6

?- sum(1,S).
S = 1

?- sum(-4,S).
S = 0
*/

/*
% Εναλλακτικά:
sum(N,Sum):- sum(1,N,Sum).
sum(_,N,0):- N=<0, !.
sum(N,N,N):- !.
sum(X,N,Sum):- X1 is X+1, sum(X1,N,S1), Sum is S1+X.
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

sum2(From,To,0):- From>To, !.
sum2(F,F,F):- !.
sum2(From, To, Sum):- To1 is To-1, sum2(From,To1,S1), Sum is S1+To.

/*
?- sum2(1,3,S).
S = 6

?- sum2(3,10,S).
S = 52

?- sum2(-7,-4,S).
S = -22

?- sum2(-7,4,S).
S = -18

?- sum2(10,5,S).
S = 0
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

%reach(X,X,0).    % Αποφεύγουμε κάτι τέτοιο επειδή αποτελεί υπερ-γενίκευση:
                  % δέχεται ακόμα και reach(patra,X,0).
reach(X,X,0):- link(X,_,_); link(_,X,_).    % Αυτό είναι καλύτερο.
reach(X,Y,1):- next(X,Y).           % Θα χρησιμεύσει ως τερματικός κανόνας.
reach(X,Y,CD):-     % Αυτός είναι ο αναδρομικός κανόνας.
    CD>1,         % Χρειάζεται ώστε να μην επιχειρήσει τον αναδρομικό κανόνα
                  % σε περίπτωση που αποτύχει η reach(X,Y,1)
    next(X,Z),         % Βρίσκουμε τη γειτονική πόλη...
    CDnew is CD-1,
    reach(Z,Y,CDnew).  % ...και ξανακαλούμε την reach/3 με μικρότερη απόσταση.
% Δεν δουλεύει αν το 3ο όρισμα είναι μη δεσμευμένη μεταβλητή.
% Γι' αυτό το πρότυπο κλήσης περιορίζεται σε reach(?City1,?City2,+Link_Distance)

/*
?- reach(a,b,4).
true

?- reach(a,b,2).
false

?- reach(a,X,1).
X = z
X = s
X = t
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

reach2(X,Y,0):- reach(X,Y,0).
reach2(X,Y,1):- reach(X,Y,1).
reach2(X,Y,2):- reach(X,Y,2).
reach2(X,Y,3):- reach(X,Y,3).
reach2(X,Y,4):- reach(X,Y,4).
reach2(X,Y,5):- reach(X,Y,5).
reach2(X,Y,6):- reach(X,Y,6).
reach2(X,Y,7):- reach(X,Y,7).
reach2(X,Y,8):- reach(X,Y,8).
reach2(X,Y,9):- reach(X,Y,9).
% Τώρα το matching με το head του κανόνα θα δεσμεύσει το 3ο όρισμα.
% Έτσι το πρότυπο κλήσης γίνεται reach2(?City1,?City2,?Link_Distance)...
% ...εφ' όσον Link_Distance < 10.
% Βρίσκει πρώτα τη μικρότερη απόσταση μεταξύ δυο πόλεων,
% αλλά είναι μη-ντετερμινιστική. Επιστρέφει όλες τις δυνατές διαδρομές.

/*
?- reach2(n,i,X).
X = 1
X = 3
X = 3
X = 5
...
X = 9
false

?- reach2(n,a,X).
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

% Μοιάζει με την προηγούμενη, όμως εδώ θέλουμε να περιορίσουμε τη συνάρτηση
% στην πρώτη απάντηση μόνο (που είναι η συντομότερη).
min_link_dist(X,Y,0):- reach(X,Y,0), !. % Ουσιαστικά υλοποιούμε έναν IDS.
min_link_dist(X,Y,1):- reach(X,Y,1), !.
min_link_dist(X,Y,2):- reach(X,Y,2), !.
min_link_dist(X,Y,3):- reach(X,Y,3), !.
min_link_dist(X,Y,4):- reach(X,Y,4), !. % Πρέπει να γνωρίζουμε την διάμετρο
min_link_dist(X,Y,5):- reach(X,Y,5), !. % του χώρου καταστάσεων για να ξέρουμε
min_link_dist(X,Y,6):- reach(X,Y,6), !. % πού να σταματήσουμε. Εδώ: |l-g|=6
min_link_dist(_,_,not_connected).       % Αν το ξεπεράσουμε δεν υπάρχει σύνδεση.
% Προσοχή, δίνει σωστό αποτέλεσμα μόνο όταν καλείται ως
% min_link_dist(+City1,+City2,-Link_Distance).

/*
?- min_link_dist(a,b,X).
X = 3

?- min_link_dist(a,n,D).
D = not_connected
*/

% ------------------------------------------------------------------------------
% Ερώτημα 6
% ------------------------------------------------------------------------------

% Τώρα επιχειρούμε να φτιάξουμε μια αναδρομική έκδοση της min_link_dist/3.
find_link_dist(X,X,0):- !.
find_link_dist(X,Y,1):- next(X,Y), !.
find_link_dist(X,Y,CD):- next(X,Z), find_link_dist(Z,Y,CDn), CD is CDn+1.

/*
% (α) Δεν βρίσκει την βέλτιση απόσταση.
?- find_link_dist(a,r,D).
D = 4
D = 6
D = 8
D = 10
D = 12
D = 14
...
% Η σειρά με την οποία έχουμε γράψει τα links επηρεάζει την αναζήτηση.

% (β) Πέφτει σε ατέρμονο loop αν δεν υπάρχει σύνδεση:
?- find_link_dist(b,u,D).
(loop)

% ... αλλά μερικές φορές ακόμα κι αν υπάρχει:
?- find_link_dist(r,a,D).
(loop)
*/

% ------------------------------------------------------------------------------
% Ερώτημα 7
% ------------------------------------------------------------------------------

find_link_dist2(X,X,0,_):- !.
find_link_dist2(X,Y,1,_):- next(X,Y), !.
find_link_dist2(X,Y,CD,Pass_prev_X):- next(X,Z), \+(Z==Pass_prev_X),
                                      find_link_dist2(Z,Y,CDn,X), CD is CDn+1.

/*
% Αναζητά προς την ίδια κατεύθυνση, αλλά δεν αποφεύγει κύκλους.

?- find_link_dist2(n,e,D,_).
D = 5
false

?- find_link_dist2(n,a,D,_).
false

?- find_link_dist2(a,n,D,_).
(loop)
*/
