% askisi_05.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 5: ΛΙΣΤΕΣ ΣΤΗΝ PROLOG
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

chop(LIST,HEAD,TAIL):- LIST = [HEAD|TAIL].

% Εναλλακτικά:
% chop([H|T],H,T).

/*
?- chop([1,2,3],H,T).
H = 1
T = [2,3]

?- chop([2,3],H,T).
H = 2
T = [3]

?- chop([3],H,T).
H = 3
T = []

?- chop([],H,T).
false

?- chop([[1,2,3],4,5],H,T).
H = [1,2,3]
T = [4,5]

?- chop(L,5,[10,20]).
L = [5,10,20]
*/

take(L,X,L2):- append(B,[X|A],L), append(B,A,L2).

/*
?- take([a,b,c,d,e],c,L).
L = [a,b,d,e]
*/

% ------------------------------------------------------------------------------
% Από προηγούμενη άσκηση:
% ------------------------------------------------------------------------------

link(a,z,75).  link(a,s,140). link(a,t,118). link(z,o,71).  link(o,s,151).
link(t,l,111). link(l,m,70).  link(m,d,75).  link(d,c,120). link(c,r,146).
link(c,p,138). link(s,r,80).  link(r,p,97).  link(p,b,101). link(s,f,99).
link(f,b,211). link(b,g,90).  link(u,h,98).  link(h,e,86).  link(u,v,142).
link(v,i,92).  link(n,i,87).

next(X,Y):- link(X,Y,_).
next(X,Y):- link(Y,X,_).

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

% Α' Τρόπος:
% only_once(L1,L2):- sort(L1,L2).

% Β' Τρόπος:
only_once([],[]).
only_once([E1|L1],L2):- member(E1,L1), !, only_once(L1,L2).
only_once([E1|L1],[E1|L2]):- only_once(L1,L2).

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

add_all([],0):- !.
add_all([H|T],S):- add_all(T,S1), S is S1+H.

/*
?- add_all([1,2,3],S).
S = 6

?- add_all([4,6,-11,0,9,17,4,4,2],S).
S = 35

?- add_all([],S).
S = 0
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

% (α)
smart_find_link_dist(X,X,0,_):- !.
smart_find_link_dist(X,Y,CD,History):-
    next(X,Z), \+(member(Z,History)),
    smart_find_link_dist(Z,Y,CDn,[X|History]), CD is CDn+1.
/*
?- smart_find_link_dist(g,f,D,[]).
D = 6
D = 12
D = 10
D = 13
D = 11
D = 5
D = 2

?- smart_find_link_dist(h,i,D,[]).
D = 3
false

% Με αρχικές τιμές στη Memory αποφεύγει να περάσει από τις συγκεκριμένες πόλεις.
?- smart_find_link_dist(g,f,D,[s]).
D = 2
*/

% (β)
min_link_dist2(X,Y,SCD):-
    findall(CD,smart_find_link_dist(X,Y,CD,[]),L), sort(L,SL), SL=[SCD|_].
/*
?- min_link_dist2(g,a,X).
X = 4
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

% (α)
smart_find_link_path(X,X,0,_,[X]):- !.
smart_find_link_path(X,Y,CD,History,Path):-
    next(X,Z), \+(member(Z,History)),
    smart_find_link_path(Z,Y,CDn,[X|History],Path2),
    Path=[X|Path2], CD is CDn+1.
/*
?- smart_find_link_path(g,f,D,[],P).
D = 6,
P = [g, b, p, c, r, s, f]
D = 12,
P = [g, b, p, c, d, m, l, t, a, z, o, s, f]
D = 10,
P = [g, b, p, c, d, m, l, t, a, s, f]
D = 13,
P = [g, b, p, r, c, d, m, l, t, a, z, o, s, f]
D = 11,
P = [g, b, p, r, c, d, m, l, t, a, s, f]
D = 5,
P = [g, b, p, r, s, f]
D = 2,
P = [g, b, f]
*/

/*
smart_find_link_path(X,Y,D,P):-
    smart_find_link_path(X,Y,D,[],H),
    reverse([Y|H],P).
smart_find_link_path(X,X,0,H,H):- !.
smart_find_link_path(X,Y,CD,History,Hout):-
    next(X,Z), \+(member(Z,History)),
    smart_find_link_path(Z,Y,CDn,[X|History],Hout),
    CD is CDn+1.

?- smart_find_link_path(g,f,D,P).

D = 6,
P = [g, b, p, c, r, s, f]
D = 12,
P = [g, b, p, c, d, m, l, t, a, z, o, s, f]
D = 10,
P = [g, b, p, c, d, m, l, t, a, s, f]
D = 13,
P = [g, b, p, r, c, d, m, l, t, a, z, o, s, f]
D = 11,
P = [g, b, p, r, c, d, m, l, t, a, s, f]
D = 5,
P = [g, b, p, r, s, f]
D = 2,
P = [g, b, f]
*/

% (β)
min_link_path(X,Y,SCD,Path):-
    min_link_dist2(X,Y,SCD), smart_find_link_path(X,Y,SCD,[],Path).
/*
?- min_link_path(z,g,D,P).
D = 5,
P = [z, o, s, f, b, g]
D = 5,
P = [z, a, s, f, b, g]
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

% (α)
smart_find_distance(X,X,0,_):- !.
smart_find_distance(X,Y,SumD,History):-
    next(X,Z,D), \+(member(Z,History)),
    smart_find_distance(Z,Y,SDn,[X|History]), SumD is SDn+D.
% next/3: όπως η next/2 αλλά με επιπλέον πληροφορία πραγματικής απόστασης.
next(X,Y,D):- link(X,Y,D); link(Y,X,D).
/*
?- smart_find_distance(g,f,D,[]).
D = 654
D = 1219
D = 1062
D = 1324
D = 1167
D = 467
D = 301
*/

% (β)
min_distance(X,Y,SCD):-
    findall(CD, smart_find_distance(X,Y,CD,[]), L), sort(L,SL), SL=[SCD|_].
/*
?- min_distance(g,f,D).
D = 301
*/

% (γ)
smart_find_dist_path(X,X,0,_,[X]):- !.
smart_find_dist_path(X,Y,SumD,History,Path):-
    next(X,Z,D), \+(member(Z,History)),
    smart_find_dist_path(Z,Y,SDn,[X|History],Path2),
    Path=[X|Path2], SumD is SDn+D.
/*
?- smart_find_dist_path(g,f,D,[],P).
D = 654,
P = [g, b, p, c, r, s, f]
D = 1219,
P = [g, b, p, c, d, m, l, t, a, z, o, s, f]
D = 1062,
P = [g, b, p, c, d, m, l, t, a, s, f]
D = 1324,
P = [g, b, p, r, c, d, m, l, t, a, z, o, s, f]
D = 1167,
P = [g, b, p, r, c, d, m, l, t, a, s, f]
D = 467,
P = [g, b, p, r, s, f]
D = 301,
P = [g, b, f]
*/

% (δ)
min_dist_path(X,Y,SCD,Path):-
    min_distance(X,Y,SCD), smart_find_dist_path(X,Y,SCD,[],Path).
/*
?- min_dist_path(a,b,X,P).
X = 418,
P = [a, s, r, p, b]
false

?- min_dist_path(g,f,D,P).
D = 301,
P = [g, b, f]
*/
