% askisi_06.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 6: AUTOEXECUTABLE GOALS, ASSERT/RETRACT ΚΑΙ ΤΕΛΕΣΤΕΣ
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

/*
paragontiko(1,1):- !.
paragontiko(X,Y):- X2 is X-1,
            paragontiko(X2,Y2),
            Y is Y2*X.

?- paragontiko(5,X).
X = 120
*/

:- dynamic paragontiko/2.
paragontiko(1,1):- !.
paragontiko(X,Y):- X2 is X-1,
            paragontiko(X2,Y2),
            Y is Y2*X,
            asserta(paragontiko(X,Y):- !).
/*
% Αν τρέξετε τον κώδικα στο https://swish.swi-prolog.org/ υπάρχει περίπτωση
% να μη σας δίνει άδεια να εκτελέσετε εντολές assert και retract.
% Σε αυτήν την περίπτωση δοκιμάστε στο https://wasm.swi-prolog.org/wasm/shell
% ή σε εγκατεστημένη στον υπολογιστή σας έκδοση της Prolog.

?- paragontiko(5,X).
X = 120

?- listing.
paragontiko(5,120):- !.
paragontiko(4,24):- !.
paragontiko(3,6):- !.
paragontiko(2,2):- !.
paragontiko(1,1):- !.
paragontiko(A,B):-
    C is A-1,
    paragontiko(C,D),
    B is D*A,
    asserta((paragontiko(A,B):-!)).
*/

father(alex,bill).
father(bill,charlie).
father(charlie,don).

:- op(700, xfx, is_father_of).

alex is_father_of bill.
bill is_father_of charlie.
charlie is_father_of don.

X is_father_of Y :- father(X,Y).

vowel_list(['α'/'ά','ε'/'έ','η'/'ή','ι'/'ί','o'/'ό','υ'/'ύ','ω'/'ώ']).
stress(X,Y):- vowel_list(L), member(X/Y,L).

/*
?- stress(α,X).
X = ά
false

?- stress(X,έ).
X = ε
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

% (α)
make(From,_,0,[From]):- !.
make(From,To,Step,[]):- Step>0, From>To, !.
make(From,To,Step,[]):- Step<0, From<To, !.
make(From,To,Step,[From|Tail]):- NewFrom is From+Step,
    make(NewFrom,To,Step,Tail).

/*
?- make(1,4,1,L).
L = [1, 2, 3, 4]

?- make(7,20,4,L).
L = [7, 11, 15, 19]

?- make(5,-6,-2,L).
L = [5, 3, 1, -1, -3, -5]

?- make(9,9,-11,L).
L = [9]

?- make(5,10,0,L).
L = [5]
*/

% (β)
/*
:- dynamic link/2.
make(From,_,0,[From]):- !.
make(From,To,Step,[]):- Step>0, From>To, retract(link(_,From)), !.
make(From,To,Step,[]):- Step<0, From<To, retract(link(_,From)), !.
make(From,To,Step,[From|Tail]):- NewFrom is From+Step,
    assert(link(From,NewFrom)),
    make(NewFrom,To,Step,Tail).

?- make(1,4,1,L).
L = [1, 2, 3, 4].

?- make(1,4,1,L).
L = [1, 2, 3, 4].

?- listing(link).
link(1, 2).
link(2, 3).
link(3, 4).
link(1, 2).
link(2, 3).
link(3, 4).
true
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

% (α)
fib(A,B,C):- C is A+B.
fib(A,B,D):- C is A+B, fib(B,C,D).

fib(1).
fib(1).
fib(C):- fib(1,1,C).

/*
?- fib(Ν).
Ν = 1
Ν = 1
Ν = 2
Ν = 3
Ν = 5
Ν = 8
Ν = 13
Ν = 21
Ν = 34
Ν = 55
...
*/

% (β)
:- dynamic f/2.

fib(A,B,C,N1,N2):- C is A+B, N2 is N1+1.
fib(A,B,D,N1,N3):- C is A+B, N2 is N1+1, fib(B,C,D,N2,N3).

fib(1,1).
fib(2,1).
fib(N,F):- fib(1,1,F,2,N).

store(Limit):- retractall(f(_,_)), fib(N,F), assert(f(N,F)), N>=Limit, !.

/*
?- fib(N,F).
F = N, N = 1
F = 1,
N = 2
F = 2,
N = 3
F = 3,
N = 4
F = N, N = 5
F = 8,
N = 6
F = 13,
N = 7
F = 21,
N = 8
...

?- store(10).
true

?- listing(f).
f(1, 1).
f(2, 1).
f(3, 2).
f(4, 3).
f(5, 5).
f(6, 8).
f(7, 13).
f(8, 21).
f(9, 34).
f(10, 55).
true
*/

% (γ)
/*
:- store(100).
:- op(700, xfx, nth_fib).
N nth_fib F :- f(N,F).
*/

/*
?- 99 nth_fib F.
F = 218922995834555169026

?- N nth_fib 1100087778366101931.
N = 88
*/
