% askisi_07.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 7: ΑΠΟΣΦΑΛΜΑΤΩΣΗ (DEBUGGING)
% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

/*
what.
what :- what.

% (α)
?- what, write('ONE'), nl, fail.
ONE
ONE
ONE
 :
 :

% (β)
?- !, what, write('TWO'), nl, fail.
TWO
TWO
TWO
 :
 :

% (γ)
?- what, !, write('THREE'), nl, fail.
THREE
false

% (δ)
?- what, write('FOUR'), nl, !, fail.
FOUR
false

% (ε)
?- what, write('FIVE'), nl, fail, !.
FIVE
FIVE
FIVE
  :
  :
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

/*
addlist([],[],[]).
addlist([E1],[E2],[E3]):- E3 is E1+E2.
addlist([H1|T1],[H2|T2],[H3|T3]):- H3 is H1+H2,
    addlist(T1,T2,T3).

?- addlist([4,1,3,2],[5,6,1,0],X).
X = [9, 7, 4, 2]
X = [9, 7, 4, 2]
*/

addlist([],[],[]).
addlist([H1|T1],[H2|T2],[H3|T3]):- H3 is H1+H2,
    addlist(T1,T2,T3).

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

:- dynamic g/2.

f(X,Y,_):- assert(g(X,Y)), fail.
f(_,_,Y):- retract(g(X,Z)), Y is X+Z.

/*
?- f(11,8,X).
X = 19
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

f(1,one).
f(s(1),two).
f(s(s(1)),three).
f(s(s(s(X))),N) :- f(X,N).

/*
?- f(s(1),A), write(A), nl,
	   f(s(s(s(s(s(s(1)))))),B), write(B), nl,
	   f(C,three), write(C), nl, A=B.
two
one
s(s(1))
s(s(s(s(s(1)))))
s(s(s(s(s(s(s(s(1))))))))
	:
	:
	:
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

a(32,20):-!.
a(X,Y):- f1(X,Z), b(Z,Y).
b(X,Y):- f2(X,Z), a(Z,Y).
f1(N,NewN):- NewN is N+4.
f2(N,NewN):- NewN is N*2.

/*
% (α)
?- a(2,Reply).
Reply = 20

?- a(12,Reply).
Reply = 20

?- a(22,Reply).
(loop)

% (β)
?- a(-3,20).
true

% λ = -3
*/

% ------------------------------------------------------------------------------
% Ερώτημα 6
% ------------------------------------------------------------------------------

/*
function([],[]):- !.
function([H|T],[H|R]):- function(T,R).
function([H|T],L):- function(H,L1), function(T,L2),
    append(L1,L2,T).

?- function([a,b,c,d],X).
X = [a, b, c, d]

?- function([a,[b,c],d],X).
X = [a, [b, c], d]
X = [a, b, c, d]

?- function([[a],[[b]],[c,[d]]],X).
X = [[a], [[b]], [c, [d]]]
X = [[a], [[b]], c, [d]]
X = [[a], [[b]], c, d]
X = [[a], [b], [c, [d]]]
X = [[a], [b], c, [d]]
X = [[a], [b], c, d]
X = [[a], b, [c, [d]]]
X = [[a], b, c, [d]]
X = [[a], b, c, d]
X = [a, [[b]], [c, [d]]]
X = [a, [[b]], c, [d]]
X = [a, [[b]], c, d]
X = [a, [b], [c, [d]]]
X = [a, [b], c, [d]]
X = [a, [b], c, d]
X = [a, b, [c, [d]]]
X = [a, b, c, [d]]
X = [a, b, c, d]
*/

function([],[]):- !.
function([H|T],[H|R]):- \+ H=[_|_], function(T,R).
function([H|T],L):- function(H,L1), function(T,L2),
    append(L1,L2,L).

% ------------------------------------------------------------------------------
% Ερώτημα 7
% ------------------------------------------------------------------------------

function([],[]):- !.
function([H|T],[H|R]):- \+ member(H,T), !, function(T,R).
function([_|T],R):- function(T,R).

% (α)

/*
?- function([8,2,1,7,1,4,5,5,8,9],X).
X = [2, 7, 1, 4, 5, 8, 9]
*/

% (β)

:- op(700,xfx,gives).		% εδώ ορίζεται o τελεστής
A gives B :- function(A,B).	% και εδώ η λειτουργία του

/*
?- [8,2,1,7,1,4,5,5,8,9] gives X.
X = [2, 7, 1, 4, 5, 8, 9]
*/

function([],[]):- !.
function([H|T],[H|R]):- \+ member(H,T), !, T gives R.
function([_|T],R):- T gives R.

/*
?- function([8,2,1,7,1,4,5,5,8,9],X).
X = [2, 7, 1, 4, 5, 8, 9]
*/

% ------------------------------------------------------------------------------
% Ερώτημα 8
% ------------------------------------------------------------------------------

order([],[]).
order([H|T],[H|R]):- order(T,L), reverse(L,R).

/*
% (α)
?- order([1,2,3,4,5,6],X).
X = [1, 3, 5, 6, 4, 2]

% (β)
?- order([100,99,98,....,3,2,1],X).
X = [100,98,96,94,....,4,2,1,3,....,93,95,97,99]
*/
