% askisi_08.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 8: ΙΚΑΝΟΠΟΙΗΣΗ ΠΕΡΙΟΡΙΣΜΩΝ
% ------------------------------------------------------------------------------
% Υπόβαθρο
% ------------------------------------------------------------------------------

sentence     -->   noun_phrase, verb_phrase.
noun_phrase  -->   determiner, noun.
verb_phrase  -->   verb; verb, noun_phrase.
determiner   -->   [the].
noun         -->   [boy]; [house].
verb         -->   [likes].

/*
?- phrase(sentence, [the,boy,likes,the,house]).
true

?- phrase(sentence, [the,boy,likes]).
true

?- phrase(sentence, [the,girl,likes]).
false

?- phrase(sentence, [the,likes,boy]).
false

?- phrase(noun_phrase,[the,house]).
true

?- phrase(determiner,[the]).
true

?- phrase(noun_phrase, [the,boy,likes,the,house], R).
R = [likes,the,house]

?- phrase(verb_phrase, [the,boy,likes,the,house], R).
false

?- phrase(verb_phrase, [likes,the,house], R).
R = [the,house]
R = []
false

?- phrase(sentence, S).
S = [the,boy,likes]
S = [the,boy,likes,the,boy]
S = [the,boy,likes,the,house]
S = [the,house,likes]
S = [the,house,likes,the,boy]
S = [the,house,likes,the,house]
false

?- phrase(verb_phrase,V).
V = [likes]
V = [likes,the,boy]
V = [likes,the,house]
false
*/

sentence(N)    -->  noun_phrase(N), verb_phrase(N).
noun_phrase(N) -->  determiner(N), noun(N).
verb_phrase(N) -->  verb(N); verb(N), noun_phrase(_).
determiner(_)  -->  [the].
noun(singular) -->  [boy]; [house].
noun(plural)   -->  [boys]; [houses].
verb(singular) -->  [likes].
verb(plural)   -->  [like].

/*
?- phrase(sentence(X), [the,boy,likes,the,houses]).
X = singular

?- phrase(sentence(plural), [the,boys,like]).
true

?- phrase(sentence(plural), [the,boy,likes]).
false

?- phrase(sentence(X), [the,boys,likes]).
false
*/

/*
sentence(sentence(N,V))       --> noun_phrase(N),verb_phrase(V).
noun_phrase(noun_phrase(D,N)) --> determiner(D), noun(N).
verb_phrase(verb_phrase(V))   --> verb(V).
verb_phrase(verb_phrase(V,N)) --> verb(V), noun_phrase(N).
determiner(determiner(the))   --> [the].
noun(noun(boy))               --> [boy].
noun(noun(house))             --> [house].
verb(verb(likes))             --> [likes].


?- phrase(sentence(X), [the,boy,likes,the,house]).
X = sentence(noun_phrase(determiner(the), noun(boy)), verb_phrase(verb(likes),
	noun_phrase(determiner(the), noun(house))))
*/

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

% (α)
gAND(0,0,0).
gAND(0,1,0).
gAND(1,0,0).
gAND(1,1,1).

/*
?- gAND(1,0,Z).
Z = 0
false

?- gAND(X,Y,0).
X = Y, Y = 0
X = 0,
Y = 1
X = 1,
Y = 0

?- gAND(X,Y,Z).
X = Y, Y = Z, Z = 0
X = Z, Z = 0,
Y = 1
X = 1,
Y = Z, Z = 0
X = Y, Y = Z, Z = 1
*/

% (β)
gOR(0,0,0).
gOR(0,1,1).
gOR(1,0,1).
gOR(1,1,1).

gNOT(0,1).
gNOT(1,0).

gNAND(0,0,1).
gNAND(0,1,1).
gNAND(1,0,1).
gNAND(1,1,0).

gNOR(0,0,1).
gNOR(0,1,0).
gNOR(1,0,0).
gNOR(1,1,0).

gXOR(0,0,0).
gXOR(0,1,1).
gXOR(1,0,1).
gXOR(1,1,0).

gXNOR(0,0,1).
gXNOR(0,1,0).
gXNOR(1,0,0).
gXNOR(1,1,1).

/*
% Εναλλακτικά:
gNAND(In1,In2,Out):- gAND(In1,In2,A), gNOT(A,Out).

gNOR(In1,In2,Out):- gOR(In1,In2,A), gNOT(A,Out).

gXOR(In1,In2,Out):- gOR(In1,In2,A), gAND(In1,In2,B), gNOT(B,C),
    gAND(A,C,Out).

gXNOR(In1,In2,Out):- gXOR(In1,In2,A), gNOT(A,Out).
*/

% (γ)
circuit1(A,B,C,F):- gAND(A,B,X1), gNAND(B,C,X2), gOR(X1,X2,F).

/*
?- circuit1(0,1,1,F).
F = 0

?- circuit1(1,B,C,1).
B = C, C = 0
B = 0,
C = 1
B = 1,
C = 0
B = C, C = 1

?- circuit1(A,B,C,F).
A = B, B = C, C = 0,
F = 1
A = B, B = 0,
C = F, F = 1
A = C, C = 0,
B = F, F = 1
A = F, F = 0,
B = C, C = 1
A = F, F = 1,
B = C, C = 0
A = C, C = F, F = 1,
B = 0
A = B, B = F, F = 1,
C = 0
A = B, B = C, C = F, F = 1
*/

% (δ)
circuit2(A,B,C,F):- gXOR(A,B,X1), gXOR(B,C,X2),
		gNOT(A,NA), gNOT(B,NB), gNOR(NA,NB,X3),
		gNOR(A,C,X4), gNAND(X1,X2,X5),
		gOR(X3,X4,X6), gNAND(X5,X6,F).

/*
?- circuit2(1,0,1,F).
F = 1

?- circuit2(Α,B,C,0).
B = C, C = Α, Α = 0
B = Α, Α = 1,
C = 0
B = C, C = Α, Α = 1

?- circuit2(A,B,C,F).
A = B, B = C, C = F, F = 0
A = B, B = 0,
C = F, F = 1
A = C, C = 0,
B = F, F = 1
A = 0,
B = C, C = F, F = 1
A = F, F = 1,
B = C, C = 0
A = C, C = F, F = 1,
B = 0
A = B, B = 1,
C = F, F = 0
A = B, B = C, C = 1,
F = 0
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

% (α)
solve(VarList):-
    VarList=[D,E,M,N,O,R,S,Y],     % Οι μεταβλητές του προβλήματος
    Digits=[0,1,2,3,4,5,6,7,8,9],  % Οι τιμές των μεταβλητών (τα ψηφία)
    member(D,Digits),
    member(E,Digits),
    member(M,Digits),
    member(N,Digits),          % Ανάθεση τιμών στις μεταβλητές
    member(O,Digits),
    member(R,Digits),
    member(S,Digits),
    member(Y,Digits),
    M\=0, S\=0,                % Περιορισμοί
    E\=D,
    M\=D, M\=E,
    N\=D, N\=E, N\=M,
    O\=D, O\=E, O\=M, O\=N,
    R\=D, R\=E, R\=M, R\=N, R\=O,
    S\=D, S\=E, S\=M, S\=N, S\=O, S\=R,
    Y\=D, Y\=E, Y\=M, Y\=N, Y\=O, Y\=R, Y\=S,
    S*1000+E*100+N*10+D + M*1000+O*100+R*10+E =:= M*10000+O*1000+N*100+E*10+Y.

show([D,E,M,N,O,R,S,Y]):-
    Num1 is S*1000+E*100+N*10+D,
    Num2 is M*1000+O*100+R*10+E,
    Num3 is M*10000+O*1000+N*100+E*10+Y,
    write(Num1),write('+'),write(Num2),write('='),write(Num3),nl.

go:- solve(V), show(V).

/*
?- time(go).
9567+1085=10652
% 761,192,607 inferences, 116.438 CPU in 99.797 seconds (117% CPU, 6537349 Lips)
*/

% (β)
solve2(VarList):-
    VarList=[D,E,M,N,O,R,S,Y],
    Digits=[0,1,2,3,4,5,6,7,8,9],
    member(D,Digits),
    member(E,Digits), E\=D,
    member(M,Digits), M\=0, M\=D, M\=E,
    member(N,Digits), N\=D, N\=E, N\=M,
    member(O,Digits), O\=D, O\=E, O\=M, O\=N,
    member(R,Digits), R\=D, R\=E, R\=M, R\=N, R\=O,
    member(S,Digits), S\=0, S\=D, S\=E, S\=M, S\=N, S\=O, S\=R,
    member(Y,Digits), Y\=D, Y\=E, Y\=M, Y\=N, Y\=O, Y\=R, Y\=S,
    S*1000+E*100+N*10+D + M*1000+O*100+R*10+E =:= M*10000+O*1000+N*100+E*10+Y.

go2:- solve2(V), show(V).

/*
?- time(go2).
9567+1085=10652
% 30,906,148 inferences, 8.453 CPU in 8.500 seconds (99% CPU, 3656180 Lips)
*/

% (γ)
% SEND+NO+MORE=MONEY
solve3(VarList):-
    VarList=[D,E,M,N,O,R,S,Y],
    Digits=[0,1,2,3,4,5,6,7,8,9],
    member(D,Digits),
    member(E,Digits), E\=D,
    member(M,Digits), M\=0, M\=D, M\=E,
    member(N,Digits), N\=0, N\=D, N\=E, N\=M,
    member(O,Digits), O\=D, O\=E, O\=M, O\=N,
    member(R,Digits), R\=D, R\=E, R\=M, R\=N, R\=O,
    member(S,Digits), S\=0, S\=D, S\=E, S\=M, S\=N, S\=O, S\=R,
    member(Y,Digits), Y\=D, Y\=E, Y\=M, Y\=N, Y\=O, Y\=R, Y\=S,
    S*1000+E*100+N*10+D + N*10+O + M*1000+O*100+R*10+E =:=
        M*10000+O*1000+N*100+E*10+Y.

show3([D,E,M,N,O,R,S,Y]):-
    Num1 is S*1000+E*100+N*10+D,
    Num2 is N*10+O,
    Num3 is M*1000+O*100+R*10+E,
    Num4 is M*10000+O*1000+N*100+E*10+Y,
    write(Num1),write('+'),write(Num2),write('+'),write(Num3),
        write('='),write(Num4),nl.

go3:- solve3(V), show3(V).

% (δ)
go4:- solve3(V), show3(V), fail.

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

% (α)
print_board([S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12,S13,S14,S15,S16]):-
  write((S1,S2,S3,S4)), nl,
  write((S5,S6,S7,S8)), nl,
  write((S9,S10,S11,S12)), nl,
  write((S13,S14,S15,S16)), nl, nl.

alldiff([_]):- !.
alldiff([H|T]):- \+ member(H,T), alldiff(T).

fill([]):- !.
fill([H|T]):- member(H,[1,2,3,4]), fill(T).

board(B):-
  B = [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12,S13,S14,S15,S16],
  S1=1, S11=4, S14=3, S8=2, % 1 solution
  %S1=1, S2=2, S5=3, S6=4, % 12 solutions
  !,
  fill(B),

  alldiff([S1,S2,S3,S4]),
  alldiff([S5,S6,S7,S8]),
  alldiff([S9,S10,S11,S12]),
  alldiff([S13,S14,S15,S16]),

  alldiff([S1,S5,S9,S13]),
  alldiff([S2,S6,S10,S14]),
  alldiff([S3,S7,S11,S15]),
  alldiff([S4,S8,S12,S16]),

  alldiff([S1,S2,S5,S6]),
  alldiff([S3,S4,S7,S8]),
  alldiff([S9,S10,S13,S14]),
  alldiff([S11,S12,S15,S16]).

go:- board(B), print_board(B), fail.

/*
?- time(go).
1,2,3,4
3,4,1,2
2,1,4,3
4,3,2,1

% 190,678,829 inferences, 14.579 CPU in 14.687 seconds (99% CPU, 13079187 Lips)
false
*/

% (β)
/*
% ΠΡΟΣΟΧΗ: Πρέπει να μπει σε comments ο κώδικας του Ερωτήματος 3(α) για να τρέξει.

print_board([S11,S12,S13,S14,S15,S16,S17,S18,S19,
  S21,S22,S23,S24,S25,S26,S27,S28,S29,
  S31,S32,S33,S34,S35,S36,S37,S38,S39,
  S41,S42,S43,S44,S45,S46,S47,S48,S49,
  S51,S52,S53,S54,S55,S56,S57,S58,S59,
  S61,S62,S63,S64,S65,S66,S67,S68,S69,
  S71,S72,S73,S74,S75,S76,S77,S78,S79,
  S81,S82,S83,S84,S85,S86,S87,S88,S89,
  S91,S92,S93,S94,S95,S96,S97,S98,S99]):-
  write((S11,S12,S13,S14,S15,S16,S17,S18,S19)), nl,
  write((S21,S22,S23,S24,S25,S26,S27,S28,S29)), nl,
  write((S31,S32,S33,S34,S35,S36,S37,S38,S39)), nl,
  write((S41,S42,S43,S44,S45,S46,S47,S48,S49)), nl,
  write((S51,S52,S53,S54,S55,S56,S57,S58,S59)), nl,
  write((S61,S62,S63,S64,S65,S66,S67,S68,S69)), nl,
  write((S71,S72,S73,S74,S75,S76,S77,S78,S79)), nl,
  write((S81,S82,S83,S84,S85,S86,S87,S88,S89)), nl,
  write((S91,S92,S93,S94,S95,S96,S97,S98,S99)), nl,
  nl.

alldiff([_]):- !.
alldiff([H|T]):- \+ member(H,T), alldiff(T).

board(B):-
  B = [S11,S12,S13,S14,S15,S16,S17,S18,S19,
    S21,S22,S23,S24,S25,S26,S27,S28,S29,
    S31,S32,S33,S34,S35,S36,S37,S38,S39,
    S41,S42,S43,S44,S45,S46,S47,S48,S49,
    S51,S52,S53,S54,S55,S56,S57,S58,S59,
    S61,S62,S63,S64,S65,S66,S67,S68,S69,
    S71,S72,S73,S74,S75,S76,S77,S78,S79,
    S81,S82,S83,S84,S85,S86,S87,S88,S89,
    S91,S92,S93,S94,S95,S96,S97,S98,S99],

S12=8, S15=9, S17=7, S18=5, S21=5, S29=2, S34=7, S39=6, S41=3, S44=1,
S47=8, S48=7, S57=6, S63=1, S65=2, S79=5, S81=8, S84=2, S87=1, S88=3,
S92=9, S96=4, S97=2,

member(S77,[4,9]),
member(S27,[3,4,9]),
member(S37,[3,4,9]),
member(S67,[3,4,5,9]),
alldiff([S17,S27,S37,S47,S57,S67,S77,S87,S97]), % col 7

member(S19,[1,3,4]),
member(S28,[1,4,8,9]),
member(S38,[1,4,8,9]),
alldiff([S17,S18,S19,S27,S28,S29,S37,S38,S39]), % block 3

member(S99,[7,8]),
member(S98,[6,8]),
member(S89,[4,7,9]),
member(S78,[4,6,8,9]),
alldiff([S77,S78,S79,S87,S88,S89,S97,S98,S99]), % block 9

member(S68,[4,9]),
member(S58,[1,2,4,9]),
alldiff([S18,S28,S38,S48,S58,S68,S78,S88,S98]), % col 8

member(S49,[4,9]),
member(S69,[3,4,9]),
member(S59,[1,3,4,9]),
alldiff([S47,S48,S49,S57,S58,S59,S67,S68,S69]), % block 6

alldiff([S19,S29,S39,S49,S59,S69,S79,S89,S99]), % col 9

member(S45,[4,5,6]),
member(S46,[5,6,9]),
member(S42,[2,4,5,6]),
member(S43,[2,4,5,6,9]),
alldiff([S41,S42,S43,S44,S45,S46,S47,S48,S49]), % row 4

member(S14,[3,4,6]),
member(S13,[2,3,4,6]),
member(S11,[1,2,4,6]),
member(S16,[1,2,3,6]),
alldiff([S11,S12,S13,S14,S15,S16,S17,S18,S19]), % row 1

member(S85,[5,6,7]),
member(S83,[4,5,6,7]),
member(S82,[4,5,6,7]),
member(S86,[5,6,7,9]),
alldiff([S81,S82,S83,S84,S85,S86,S87,S88,S89]), % row 8

member(S91,[1,6,7]),
member(S93,[3,5,6,7]),
member(S94,[3,5,6,8]),
member(S95,[1,3,5,6,7,8]),
alldiff([S91,S92,S93,S94,S95,S96,S97,S98,S99]), % row 9

member(S74,[3,6,8,9]),
member(S75,[1,3,6,7,8]),
member(S76,[1,3,6,7,8,9]),
alldiff([S74,S75,S76,S84,S85,S86,S94,S95,S96]), % block 8

member(S24,[3,4,6,8]),
member(S54,[3,4,5,8,9]),
member(S64,[3,4,5,6,8,9]),
alldiff([S14,S24,S34,S44,S54,S64,S74,S84,S94]), % col 4

member(S61,[4,6,7,9]),
member(S62,[4,5,6,7]),
member(S66,[3,5,6,7,8,9]),
alldiff([S61,S62,S63,S64,S65,S66,S67,S68,S69]), % row 6

member(S55,[3,4,5,7,8]),
member(S56,[3,5,7,8,9]),
alldiff([S44,S45,S46,S54,S55,S56,S64,S65,S66]), % block 5

member(S26,[1,3,6,8]),
member(S36,[1,2,3,5,8]),
alldiff([S16,S26,S36,S46,S56,S66,S76,S86,S96]), % col 6

member(S25,[1,3,4,6,8]),
member(S35,[1,3,4,5,8]),
alldiff([S14,S15,S16,S24,S25,S26,S34,S35,S36]), % block 2

alldiff([S15,S25,S35,S45,S55,S65,S75,S85,S95]), % col 5

member(S23,[3,4,6,7,9]),
member(S22,[1,3,4,6,7]),
alldiff([S21,S22,S23,S24,S25,S26,S27,S28,S29]), % row 2

member(S33,[2,3,4,9]),
member(S31,[1,2,4,9]),
member(S32,[1,2,3,4]),
alldiff([S11,S12,S13,S21,S22,S23,S31,S32,S33]), % block 1

alldiff([S31,S32,S33,S34,S35,S36,S37,S38,S39]), % row 3

member(S51,[2,4,7,9]),
member(S71,[1,2,4,6,7]),
alldiff([S11,S21,S31,S41,S51,S61,S71,S81,S91]), % col 1

member(S52,[2,4,5,7]),
member(S53,[2,4,5,7,8,9]),
alldiff([S41,S42,S43,S51,S52,S53,S61,S62,S63]), % block 4

alldiff([S51,S52,S53,S54,S55,S56,S57,S58,S59]), % row 5

member(S73,[2,3,4,6,7]),
alldiff([S13,S23,S33,S43,S53,S63,S73,S83,S93]), % col 3

member(S72,[1,2,3,4,6,7]),
alldiff([S71,S72,S73,S81,S82,S83,S91,S92,S93]), % block 7

alldiff([S12,S22,S32,S42,S52,S62,S72,S82,S92]), % col 2

alldiff([S71,S72,S73,S74,S75,S76,S77,S78,S79]). % row 7

solve:- board(B), print_board(B), fail.
*/

/*
?- time(solve).
2,8,3,6,9,1,7,5,4
5,7,6,4,8,3,9,1,2
4,1,9,7,5,2,3,8,6
3,2,5,1,4,6,8,7,9
9,4,8,3,7,5,6,2,1
7,6,1,9,2,8,5,4,3
6,3,2,8,1,7,4,9,5
8,5,4,2,6,9,1,3,7
1,9,7,5,3,4,2,6,8
% 74,239,876 inferences, 4.872 CPU in 4.898 seconds (99% CPU, 15239086 Lips)
false
*/

% Για τον μεταπρογραμματιστικό κώδικα που επιλύει οποιονδήποτε γρίφο Sudoku 9x9 δείτε το ξεχωριστό αρχείο askisi_08_3b_meta.pl

% (γ)
sudoku_matrix --> row, row, row, row, row, row, row, row, row.
row --> item, item, item, item, item, item, item, item, item.
item --> [0]; [1]; [2]; [3]; [4]; [5]; [6]; [7]; [8]; [9].
% item --> [N], {member(N,[0,1,2,3,4,5,6,7,8,9])}.   % Εναλλακτικά

string_to_digitlist(S,DL):- string_chars(S,CL),
    chars_to_digits(CL,DL).

chars_to_digits([],[]).
chars_to_digits([HC|CL],[HD|DL]):- atom_number(HC,HD),
    chars_to_digits(CL,DL).

boardstring("080090750500000002000700006300100870000000600001020000000000005800200130090004000").

check:- boardstring(S), string_to_digitlist(S,DL),
    phrase(sudoku_matrix,DL).

/*
?- check.
true
*/

sudoku_matrix(W) --> row(R1), row(R2), row(R3), row(R4), row(R5), row(R6),
    row(R7), row(R8), row(R9),
    {findall((A,B,C),
             (A=1,member((B,C),R1);
              A=2,member((B,C),R2);
              A=3,member((B,C),R3);
              A=4,member((B,C),R4);
              A=5,member((B,C),R5);
              A=6,member((B,C),R6);
              A=7,member((B,C),R7);
              A=8,member((B,C),R8);
              A=9,member((B,C),R9)),
                 Q),
     findall(X, (member(X,Q), X=(_,_,C), C>0), W)}.
row([(1,C1),(2,C2),(3,C3),(4,C4),(5,C5),(6,C6),(7,C7),(8,C8),(9,C9)]) -->
    item(C1), item(C2), item(C3), item(C4), item(C5), item(C6), item(C7),
    item(C8), item(C9).
item(N) --> [N], {member(N,[0,1,2,3,4,5,6,7,8,9])}.

check(W):- boardstring(S), string_to_digitlist(S,DL),
    phrase(sudoku_matrix(W),DL).

/*
?- check(W).
W = [(1,2,8), (1,5,9), (1,7,7), (1,8,5), (2,1,5), (2,9,2), (3,4,7), (3,9,6),
(4,1,3), (4,4,1), (4,7,8), (4,8,7), (5,7,6), (6,3,1), (6,5,2), (7,9,5),
(8,1,8), (8,4,2), (8,7,1), (8,8,3), (9,2,9), (9,6,4)]
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

% Κλήση: safe_square((+X,+Y),+Squares)
% Δέχεται τις συντεταγμένες (X,Y) ενός τετραγώνου και μια λίστα Squares με
% ..συντεταγμένες τετραγώνων που θεωρείται ότι περιέχουν βασίλισσες.
% Επιστρέφει true/false ανάλογα με το αν το τετράγωνο (X,Y) είναι σε ασφαλή θέση
% ..σε σχέση με τα Squares.
safe_square(_,[]).                           % Για να είναι ασφαλές το (Χ,Υ)
safe_square((X,Y),[(Xn,Yn)|Rest_Squares]):-  % ..πρέπει να βρίσκεται:
    \+(X==Xn),          			        % ..όχι στην ίδια στήλη
    \+(Y==Yn),          					    % ..ούτε στην ίδια γραμμή
    \+(Yn-Y =:= Xn-X),                % ..ούτε στην ίδια διαγώνιο
    \+(Yn-Y =:= X-Xn),                % ..με το διπλανό τετράγωνο
   safe_square((X,Y),Rest_Squares).   % ..και το ίδιο σε σχέση με τα υπόλοιπα

% (α)
safe_board([]).
safe_board([H|T]):- safe_board(T), safe_square(H,T).

solution1(B):-
    permutation([1,2,3,4,5,6,7,8],Y),
    Y=[Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8],
    B=[(1,Y1),(2,Y2),(3,Y3),(4,Y4),(5,Y5),(6,Y6),(7,Y7),(8,Y8)],
    safe_board(B).

/*
?- solution1(B).
B = [(1,1), (2,5), (3,8), (4,6), (5,3), (6,7), (7,2), (8,4)]
B = [(1,1), (2,6), (3,8), (4,3), (5,7), (6,4), (7,2), (8,5)]
B = [(1,1), (2,7), (3,4), (4,6), (5,8), (6,2), (7,5), (8,3)]
B = [(1,1), (2,7), (3,5), (4,8), (5,2), (6,4), (7,6), (8,3)]
B = [(1,2), (2,4), (3,6), (4,8), (5,3), (6,1), (7,7), (8,5)]
...
*/

safe_board2([]).
safe_board2([(X,Y)|Rest]):-
    safe_board2(Rest),
    member(Y,[1,2,3,4,5,6,7,8]),
    safe_square((X,Y),Rest).

solution2(B):-
    B=[(1,_),(2,_),(3,_),(4,_),(5,_),(6,_),(7,_),(8,_)], safe_board2(B).

/*
?- solution2(B).
B = [(1,4), (2,2), (3,7), (4,3), (5,6), (6,8), (7,5), (8,1)]
B = [(1,5), (2,2), (3,4), (4,7), (5,3), (6,8), (7,6), (8,1)]
B = [(1,3), (2,5), (3,2), (4,8), (5,6), (6,4), (7,7), (8,1)]
B = [(1,3), (2,6), (3,4), (4,2), (5,8), (6,5), (7,7), (8,1)]
B = [(1,5), (2,7), (3,1), (4,3), (5,8), (6,6), (7,4), (8,2)]
...
*/

increase([],[(8,Y)]):- member(Y,[1,2,3,4,5,6,7,8]).
increase(L,[(X,Y)|L]):-
    L=[(Xn,_)|_], X is Xn-1,
    member(Y,[1,2,3,4,5,6,7,8]),
    safe_square((X,Y),L).

loop(L,L):- L=[(1,_)|_], !.
loop(L1,Lout):-
    increase(L1,L2),
    loop(L2,Lout).

solution3(B):- loop([],B).

/*
?- solution3(B).
B = [(1,4), (2,2), (3,7), (4,3), (5,6), (6,8), (7,5), (8,1)]
B = [(1,5), (2,2), (3,4), (4,7), (5,3), (6,8), (7,6), (8,1)]
B = [(1,3), (2,5), (3,2), (4,8), (5,6), (6,4), (7,7), (8,1)]
B = [(1,3), (2,6), (3,4), (4,2), (5,8), (6,5), (7,7), (8,1)]
B = [(1,5), (2,7), (3,1), (4,3), (5,8), (6,6), (7,4), (8,2)]
...
*/

% (β)
count(N):- findall(Sol,solution1(Sol),ALL), length(ALL,N).

/*
?- count(N).
N = 92
*/
