% askisi_08_3b_meta.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 8: ΙΚΑΝΟΠΟΙΗΣΗ ΠΕΡΙΟΡΙΣΜΩΝ
% ------------------------------------------------------------------------------
% Ερώτημα 8.3β: Επίλυση Sudoku 9x9 με μεταπρογραμματισμό.
% ------------------------------------------------------------------------------

:- dynamic sq/4, logcon/2.

data(puzzle1,[
    (1,2,8),(1,5,9),(1,7,7),(1,8,5),(2,1,5),(2,9,2),(3,4,7),(3,9,6),
    (4,1,3),(4,4,1),(4,7,8),(4,8,7),(5,7,6),(6,3,1),(6,5,2),
    (7,9,5),(8,1,8),(8,4,2),(8,7,1),(8,8,3),(9,2,9),(9,6,4)]).
data(puzzle2,[
    (1,1,5),(1,2,3),(1,5,7),(2,1,6),(2,4,1),(2,5,9),(2,6,5),(3,2,9),
    (3,3,8),(3,8,6),(4,1,8),(4,5,6),(4,9,3),(5,1,4),(5,4,8),(5,6,3),
    (5,9,1),(6,1,7),(6,5,2),(6,9,6),(7,2,6),(7,7,2),(7,8,8),(8,4,4),
    (8,5,1),(8,6,9),(8,9,5),(9,5,8),(9,8,7),(9,9,9)]).
data(puzzle3,[
    (1,2,4),(1,5,9),(1,9,1),(2,1,8),(2,5,4),(2,9,6),(3,2,2),(3,4,5),
    (3,7,3),(4,1,9),(4,2,1),(4,7,4),(5,3,7),(5,6,2),(6,6,7),(6,8,8),
    (6,9,3),(7,3,9),(7,5,6),(8,4,3),(8,6,4),(8,7,5),(9,3,8)]).
data(puzzle4,[
    (2,6,3),(2,8,8),(2,9,5),(3,3,1),(3,5,2),
    (4,4,5),(4,6,7),(5,3,4),(5,7,1),(6,2,9),
    (7,1,5),(7,8,7),(7,9,3),(8,3,2),(8,5,1),(9,5,4),(9,9,9)]).

create_constants(Label):- retractall(sq(_,_,_,_)), data(Label,D),
    member(X,D), X=(R,C,V), calc_block(R,C,B), assert(sq(R,C,B,V)), fail.
create_constants(_).

calc_block(R,C,B):- Rc is (R-1)//3, Cc is (C-1)//3, B is 3*Rc+Cc+1.

create_options:- member(R,[1,2,3,4,5,6,7,8,9]), member(C,[1,2,3,4,5,6,7,8,9]),
    proc_create_opt(R,C), fail.
create_options.

proc_create_opt(R,C):- sq(R,C,_,_), !.
proc_create_opt(R,C):- calc_block(R,C,B), assert(sq(R,C,B,[1,2,3,4,5,6,7,8,9])).

reduce_options:- sq(R,C,B,V), proc_reduce_opt(R,C,B,V), fail.
reduce_options:- sq(R,C,B,V), V=[N],
    write("Single Value: "), write(sq(R,C,B,V)), nl,
    retract(sq(R,C,B,V)), assert(sq(R,C,B,N)), !, reduce_options.
reduce_options.

proc_reduce_opt(_,_,_,V):- is_list(V), !.
proc_reduce_opt(R,_,_,I):- sq(R,C1,B1,V), update(R,C1,B1,V,I), fail.
proc_reduce_opt(_,C,_,I):- sq(R1,C,B1,V), update(R1,C,B1,V,I), fail.
proc_reduce_opt(_,_,B,I):- sq(R1,C1,B,V), update(R1,C1,B,V,I), fail.
proc_reduce_opt(_,_,_,_).

update(_,_,_,V,_):- integer(V), !.
update(R,C,B,V,I):- retract(sq(R,C,B,V)), take(V,I,Vn),
    assert(sq(R,C,B,Vn)).

take(L,E,L):- \+ member(E,L), !.
take(L,E,L2):- append(A,[E|B],L), append(A,B,L2).

print(File,Label):- open(File,write,X),
    print_header(X,Label), print_constants(X),
    log_constraints, print_constraints(X), print_footer(X),
    close(X).

print_header(X,Label):- write(X,"% Program for solving Sudoku puzzle: "),
    write(X,Label), nl(X),
    write(X,
"print_board([S11,S12,S13,S14,S15,S16,S17,S18,S19,
  S21,S22,S23,S24,S25,S26,S27,S28,S29,
  S31,S32,S33,S34,S35,S36,S37,S38,S39,
  S41,S42,S43,S44,S45,S46,S47,S48,S49,
  S51,S52,S53,S54,S55,S56,S57,S58,S59,
  S61,S62,S63,S64,S65,S66,S67,S68,S69,
  S71,S72,S73,S74,S75,S76,S77,S78,S79,
  S81,S82,S83,S84,S85,S86,S87,S88,S89,
  S91,S92,S93,S94,S95,S96,S97,S98,S99]):-
  write((S11,S12,S13,S14,S15,S16,S17,S18,S19)), nl,
  write((S21,S22,S23,S24,S25,S26,S27,S28,S29)), nl,
  write((S31,S32,S33,S34,S35,S36,S37,S38,S39)), nl,
  write((S41,S42,S43,S44,S45,S46,S47,S48,S49)), nl,
  write((S51,S52,S53,S54,S55,S56,S57,S58,S59)), nl,
  write((S61,S62,S63,S64,S65,S66,S67,S68,S69)), nl,
  write((S71,S72,S73,S74,S75,S76,S77,S78,S79)), nl,
  write((S81,S82,S83,S84,S85,S86,S87,S88,S89)), nl,
  write((S91,S92,S93,S94,S95,S96,S97,S98,S99)), nl,
  nl.

alldiff([_]):- !.
alldiff([H|T]):- \\+ member(H,T), alldiff(T).

board(B):-
  B = [S11,S12,S13,S14,S15,S16,S17,S18,S19,
    S21,S22,S23,S24,S25,S26,S27,S28,S29,
    S31,S32,S33,S34,S35,S36,S37,S38,S39,
    S41,S42,S43,S44,S45,S46,S47,S48,S49,
    S51,S52,S53,S54,S55,S56,S57,S58,S59,
    S61,S62,S63,S64,S65,S66,S67,S68,S69,
    S71,S72,S73,S74,S75,S76,S77,S78,S79,
    S81,S82,S83,S84,S85,S86,S87,S88,S89,
    S91,S92,S93,S94,S95,S96,S97,S98,S99],
    "
    ), nl(X).

print_footer(X):- write(X,
"true.

solve:- board(B), print_board(B), fail."
), nl(X).

print_constants(X):- sq(R,C,_,V), integer(V), write(X,"S"), write(X,R),
    write(X,C),write(X,"="), write(X,V), write(X,", "), retract(sq(R,C,_,V)),
    fail.
print_constants(X):- nl(X).

log_constraints:- member(S,[r,c,b]), member(E,[1,2,3,4,5,6,7,8,9]),
    assert(logcon(S,E)), fail.
log_constraints.

print_constraints(X):- logcon(_,_), !, select_constraint((Score,S,E)),
    write("Constraint: "), write(S), write(E), write(" - Score: "),
    write(Score), nl,
    print_sqs(X,S,E),
    print_ad(X,S,E), retract(logcon(S,E)), print_constraints(X).
print_constraints(_).

select_constraint(Cons):- findall(
    (Score,S,E),
    ( logcon(S,E), score_constraint(S,E,Score) ),
    L),
    msort(L,[Cons|_]).

score_constraint(r,E,Comb):- findall(V, sq(E,_,_,V), L), calc_comb(L,Comb).
score_constraint(c,E,Comb):- findall(V, sq(_,E,_,V), L), calc_comb(L,Comb).
score_constraint(b,E,Comb):- findall(V, sq(_,_,E,V), L), calc_comb(L,Comb).

calc_comb([],1).
calc_comb([H|T],VHVT):- calc(H,VH), calc_comb(T,VT), VHVT is VH*VT.

calc(E,1):- integer(E), !.
calc(L,V):- length(L,V).

print_sqs(X,S,E):-
    nl(X), member(F,[2,3,4,5,6,7,8,9]),
    ( (S=r, R=E); (S=c, C=E); (S=b, B=E) ),
    sq(R,C,B,V), is_list(V), length(V,F),
    write_sq(X,R,C,V), retract(sq(R,C,B,V)), fail.
print_sqs(_,_,_).

write_sq(X,R,C,V):- write(X,"member(S"), write(X,R), write(X,C),
    write(X,","), write(X,V), write(X,"),"), nl(X).

print_ad(X,r,1):- write(X,"alldiff([S11,S12,S13,S14,S15,S16,S17,S18,S19]), % row 1"), nl(X).
print_ad(X,r,2):- write(X,"alldiff([S21,S22,S23,S24,S25,S26,S27,S28,S29]), % row 2"), nl(X).
print_ad(X,r,3):- write(X,"alldiff([S31,S32,S33,S34,S35,S36,S37,S38,S39]), % row 3"), nl(X).
print_ad(X,r,4):- write(X,"alldiff([S41,S42,S43,S44,S45,S46,S47,S48,S49]), % row 4"), nl(X).
print_ad(X,r,5):- write(X,"alldiff([S51,S52,S53,S54,S55,S56,S57,S58,S59]), % row 5"), nl(X).
print_ad(X,r,6):- write(X,"alldiff([S61,S62,S63,S64,S65,S66,S67,S68,S69]), % row 6"), nl(X).
print_ad(X,r,7):- write(X,"alldiff([S71,S72,S73,S74,S75,S76,S77,S78,S79]), % row 7"), nl(X).
print_ad(X,r,8):- write(X,"alldiff([S81,S82,S83,S84,S85,S86,S87,S88,S89]), % row 8"), nl(X).
print_ad(X,r,9):- write(X,"alldiff([S91,S92,S93,S94,S95,S96,S97,S98,S99]), % row 9"), nl(X).

print_ad(X,c,1):- write(X,"alldiff([S11,S21,S31,S41,S51,S61,S71,S81,S91]), % col 1"), nl(X).
print_ad(X,c,2):- write(X,"alldiff([S12,S22,S32,S42,S52,S62,S72,S82,S92]), % col 2"), nl(X).
print_ad(X,c,3):- write(X,"alldiff([S13,S23,S33,S43,S53,S63,S73,S83,S93]), % col 3"), nl(X).
print_ad(X,c,4):- write(X,"alldiff([S14,S24,S34,S44,S54,S64,S74,S84,S94]), % col 4"), nl(X).
print_ad(X,c,5):- write(X,"alldiff([S15,S25,S35,S45,S55,S65,S75,S85,S95]), % col 5"), nl(X).
print_ad(X,c,6):- write(X,"alldiff([S16,S26,S36,S46,S56,S66,S76,S86,S96]), % col 6"), nl(X).
print_ad(X,c,7):- write(X,"alldiff([S17,S27,S37,S47,S57,S67,S77,S87,S97]), % col 7"), nl(X).
print_ad(X,c,8):- write(X,"alldiff([S18,S28,S38,S48,S58,S68,S78,S88,S98]), % col 8"), nl(X).
print_ad(X,c,9):- write(X,"alldiff([S19,S29,S39,S49,S59,S69,S79,S89,S99]), % col 9"), nl(X).

print_ad(X,b,1):- write(X,"alldiff([S11,S12,S13,S21,S22,S23,S31,S32,S33]), % block 1"), nl(X).
print_ad(X,b,2):- write(X,"alldiff([S14,S15,S16,S24,S25,S26,S34,S35,S36]), % block 2"), nl(X).
print_ad(X,b,3):- write(X,"alldiff([S17,S18,S19,S27,S28,S29,S37,S38,S39]), % block 3"), nl(X).
print_ad(X,b,4):- write(X,"alldiff([S41,S42,S43,S51,S52,S53,S61,S62,S63]), % block 4"), nl(X).
print_ad(X,b,5):- write(X,"alldiff([S44,S45,S46,S54,S55,S56,S64,S65,S66]), % block 5"), nl(X).
print_ad(X,b,6):- write(X,"alldiff([S47,S48,S49,S57,S58,S59,S67,S68,S69]), % block 6"), nl(X).
print_ad(X,b,7):- write(X,"alldiff([S71,S72,S73,S81,S82,S83,S91,S92,S93]), % block 7"), nl(X).
print_ad(X,b,8):- write(X,"alldiff([S74,S75,S76,S84,S85,S86,S94,S95,S96]), % block 8"), nl(X).
print_ad(X,b,9):- write(X,"alldiff([S77,S78,S79,S87,S88,S89,S97,S98,S99]), % block 9"), nl(X).

run(Label):- create_constants(Label), create_options, reduce_options,
    File='Users/.../Documents/.../code/sudoku/helpfile.pl',  % Enter file path
    print(File,Label),
    write("File complete, ready and running"), nl,
    consult(File), solve.

/*
?- run(puzzle1).
Single Value: sq(9,7,9,[2])
Constraint: c7 - Score: 72
Constraint: b3 - Score: 48
Constraint: b9 - Score: 48
Constraint: c8 - Score: 8
Constraint: b6 - Score: 24
Constraint: c9 - Score: 1
Constraint: r4 - Score: 180
Constraint: r1 - Score: 192
Constraint: r8 - Score: 192
Constraint: r9 - Score: 288
Constraint: b8 - Score: 120
Constraint: c4 - Score: 120
Constraint: r6 - Score: 96
Constraint: b5 - Score: 25
Constraint: c6 - Score: 20
Constraint: b2 - Score: 25
Constraint: c5 - Score: 1
Constraint: r2 - Score: 25
Constraint: b1 - Score: 64
Constraint: r3 - Score: 1
Constraint: c1 - Score: 20
Constraint: b4 - Score: 24
Constraint: r5 - Score: 1
Constraint: c3 - Score: 5
Constraint: b7 - Score: 6
Constraint: c2 - Score: 1
Constraint: r7 - Score: 1
File complete, ready and running
2,8,3,6,9,1,7,5,4
5,7,6,4,8,3,9,1,2
4,1,9,7,5,2,3,8,6
3,2,5,1,4,6,8,7,9
9,4,8,3,7,5,6,2,1
7,6,1,9,2,8,5,4,3
6,3,2,8,1,7,4,9,5
8,5,4,2,6,9,1,3,7
1,9,7,5,3,4,2,6,8
false
*/
