% askisi_10.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 10: ΑΛΓΟΡΙΘΜΟΙ ΑΝΑΖΗΤΗΣΗΣ ΙΙ
% ------------------------------------------------------------------------------
% Από προηγούμενη άσκηση:
% ------------------------------------------------------------------------------

search_DLS(G,G,_):- !.
search_DLS(CurrentNode,GoalNode,Limit):-
    CurrentNode=node(_,_,_,D,_), D<Limit,
    successor(CurrentNode,SuccNode),
    search_DLS(SuccNode,GoalNode,Limit).

search_IDS(CurrentNode,GoalNode,D):-
    %write('Depth = '), write(D), nl,          % Για οπτικό έλεγχο λειτουργίας.
    search_DLS(CurrentNode,GoalNode,D), !.
search_IDS(CurrentNode,GoalNode,D):-
    NewD is D+1, search_IDS(CurrentNode,GoalNode,NewD).
find_IDS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_IDS(node(0,Initial_State,move,0,null),GoalNode,0), !.

/*
successor(NODE,SNODE):-
    NODE=node(PathCost, State, Action, Depth, _),
    SNODE=node(SPathCost,SState,SAction,SDepth,SParent),
    next(State,SState,Cost), SAction=Action,  % Εξαρτώνται από το πρόβλημα.
    SDepth is Depth+1, SPathCost is PathCost+Cost, SParent=NODE.
*/

link(a,z,75).  link(a,s,140). link(a,t,118). link(z,o,71).  link(o,s,151).
link(t,l,111). link(l,m,70).  link(m,d,75).  link(d,c,120). link(c,r,146).
link(c,p,138). link(s,r,80).  link(r,p,97).  link(p,b,101). link(s,f,99).
link(f,b,211). link(b,g,90).  link(u,h,98).  link(h,e,86).  link(u,v,142).
link(v,i,92).  link(n,i,87).

next(X,Y,D):- link(X,Y,D); link(Y,X,D).

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

detailed_print(null).
detailed_print(node(TC,S,M,D,P)):-
    detailed_print(P), write(D), write(' '), write(TC), write(' '),
    write(M), write(':'), write(S), nl.

run_map:- find_IDS(a,b,R), detailed_print(R).

/*
?- run_map.
0 0 move:a
1 140 move:s
2 239 move:f
3 450 move:b
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

successor(NODE,SNODE):-
    NODE=node(PathCost, State, Action, Depth, _),
    SNODE=node(SPathCost,SState,SAction,SDepth,SParent),
%   next(State,SState,Cost), SAction=Action,      % Εξαρτώνται από το πρόβλημα.
    problem_specific(Action,State,SAction,SState,Cost),   % Καλύτερα έτσι.
    SDepth is Depth+1, SPathCost is PathCost+Cost, SParent=NODE.

% Ακολουθεί το τμήμα της συνάρτησης διαδόχων που εξαρτάται από το πρόβλημα.
% Έτσι επιλέγουμε εύκολα ποιο πρόβλημα να λύσει.
problem_specific(Action,State,SAction,SState,Cost):-
   map_ps(Action,State,SAction,SState,Cost).
%   hanoi_ps(Action,State,SAction,SState,Cost).
%   farmer_ps(Action,State,SAction,SState,Cost).
%   puzzle8_ps(Action,State,SAction,SState,Cost).

% Το πρόβλημα του οδικού χάρτη
map_ps(Action,State,SAction,SState,Cost):-
    next(State,SState,Cost), SAction=Action.

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

% (α)
% ΠΡΟΣΟΧΗ: Πρέπει να διορθωθεί η problem_specific/5 του Ερωτήματος 2 για να τρέξει.

% Το πρόβλημα των Πύργων του Ανόι
% Αρχική κατάσταση: [[1,2,3],[],[]]    Τελική κατάσταση: [[],[],[1,2,3]]
hanoi_ps(_,State,SAction,SState,Cost):-
    hanoi_next_move(State,SState,SAction), Cost=1.

hanoi_next_move([[X|L],M,R],[L,[X|M],R],'from Left to Middle'):-
    M==[]; (M=[H|_], X<H).
hanoi_next_move([[X|L],M,R],[L,M,[X|R]],'from Left to Right'):-
    R==[]; (R=[H|_], X<H).
hanoi_next_move([L,[X|M],R],[[X|L],M,R],'from Middle to Left'):-
    L==[]; (L=[H|_], X<H).
hanoi_next_move([L,[X|M],R],[L,M,[X|R]],'from Middle to Right'):-
    R==[]; (R=[H|_], X<H).
hanoi_next_move([L,M,[X|R]],[[X|L],M,R],'from Right to Left'):-
    L==[]; (L=[H|_], X<H).
hanoi_next_move([L,M,[X|R]],[L,[X|M],R],'from Right to Middle'):-
    M==[]; (M=[H|_], X<H).

run_hanoi_puzzle:-
    find_IDS([[1,2,3],[],[]],[[],[],[1,2,3]],R), detailed_print(R).

/*
?- run_hanoi_puzzle.
0 0 move:[[1, 2, 3], [], []]
1 1 from Left to Right:[[2, 3], [], [1]]
2 2 from Left to Middle:[[3], [2], [1]]
3 3 from Right to Middle:[[3], [1, 2], []]
4 4 from Left to Right:[[], [1, 2], [3]]
5 5 from Middle to Left:[[1], [2], [3]]
6 6 from Middle to Right:[[1], [], [2, 3]]
7 7 from Left to Right:[[], [], [1, 2, 3]]

run_hanoi_puzzle:-
    find_IDS([[1,2,3,4],[],[]],[[],[],[1,2,3,4]],R), detailed_print(R).

?- run_hanoi_puzzle.
0 0 move:[[1, 2, 3, 4], [], []]
1 1 from Left to Middle:[[2, 3, 4], [1], []]
2 2 from Left to Right:[[3, 4], [1], [2]]
3 3 from Middle to Right:[[3, 4], [], [1, 2]]
4 4 from Left to Middle:[[4], [3], [1, 2]]
5 5 from Right to Left:[[1, 4], [3], [2]]
6 6 from Right to Middle:[[1, 4], [2, 3], []]
7 7 from Left to Middle:[[4], [1, 2, 3], []]
8 8 from Left to Right:[[], [1, 2, 3], [4]]
9 9 from Middle to Right:[[], [2, 3], [1, 4]]
10 10 from Middle to Left:[[2], [3], [1, 4]]
11 11 from Right to Left:[[1, 2], [3], [4]]
12 12 from Middle to Right:[[1, 2], [], [3, 4]]
13 13 from Left to Middle:[[2], [1], [3, 4]]
14 14 from Left to Right:[[], [1], [2, 3, 4]]
15 15 from Middle to Right:[[], [], [1, 2, 3, 4]]
*/

% (β)
hanoi(0,_,_,_) :- !.
hanoi(N,A,B,C) :-
    M is N-1, hanoi(M,A,C,B),
    write([move,from,A,to,B]), nl,
    hanoi(M,C,B,A).

/*
?- hanoi(3,left,right,middle).
[move,from,left,to,right]
[move,from,left,to,middle]
[move,from,right,to,middle]
[move,from,left,to,right]
[move,from,middle,to,left]
[move,from,middle,to,right]
[move,from,left,to,right]

?- hanoi(4,left,right,middle).
[move, from, left, to, middle]
[move, from, left, to, right]
[move, from, middle, to, right]
[move, from, left, to, middle]
[move, from, right, to, left]
[move, from, right, to, middle]
[move, from, left, to, middle]
[move, from, left, to, right]
[move, from, middle, to, right]
[move, from, middle, to, left]
[move, from, right, to, left]
[move, from, middle, to, right]
[move, from, left, to, middle]
[move, from, left, to, right]
[move, from, middle, to, right]
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

% ΠΡΟΣΟΧΗ: Πρέπει να διορθωθεί η problem_specific/5 του Ερωτήματος 2 για να τρέξει.

% Το πρόβλημα του Αγρότη
% Αρχική κατάσταση: s([a,k,l,m],[])    Τελική κατάσταση: s([], [a,k,l,m])

farmer_ps(_,State,SAction,SState,Cost):-
    farmer_next_move(State,SState,SAction), Cost=1.

farmer_next_move(s([a|LT],R),s(LT,[a|R]),((a),right)):- is_safe(LT).
farmer_next_move(s(L,[a|RT]),s([a|L],RT),((a),left)):- is_safe(RT).
farmer_next_move(s([a|LT],R),s(Ln,[a|Rn]),((a,Passenger),right)):-
    member(Passenger,LT), remove(LT,Passenger,Ln), is_safe(Ln),
    msort([Passenger|R],Rn).
farmer_next_move(s(L,[a|RT]),s([a|Ln],Rn),((a,Passenger),left)):-
    member(Passenger,RT), remove(RT,Passenger,Rn), is_safe(Rn),
    msort([Passenger|L],Ln).

is_safe(L):- member(l,L),member(k,L),!,fail.
is_safe(L):- member(m,L),member(k,L),!,fail.
is_safe(_).

remove(L,X,L2):- append(A,[X|B],L), append(A,B,L2).

run_farmer_puzzle:-
    find_IDS(s([a,k,l,m],[]),s([],[a,k,l,m]),R), detailed_print(R).

/*
?- run_farmer_puzzle.
0 0 move:s([a, k, l, m],[])
1 1 (a,k),right:s([l, m],[a, k])
2 2 a,left:s([a, l, m],[k])
3 3 (a,l),right:s([m],[a, k, l])
4 4 (a,k),left:s([a, k, m],[l])
5 5 (a,m),right:s([k],[a, l, m])
6 6 a,left:s([a, k],[l, m])
7 7 (a,k),right:s([],[a, k, l, m])
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

% (α)
% ΠΡΟΣΟΧΗ: Πρέπει να διορθωθεί η problem_specific/5 του Ερωτήματος 2 για να τρέξει.

% Το Πρόβλημα των 8 Πλακιδίων
% initial state: s(1,2,3,4,0,5,6,7,8)    final state: s(1,2,3,4,5,6,7,8,0)

puzzle8_ps(_,State,SAction,SState,Cost):-
    puzzle8_next_move(State,SState,SAction), Cost=1.

puzzle8_next_move(s(0,A,B,C,D,E,F,G,H),s(A,0,B,C,D,E,F,G,H),(A,left)).
puzzle8_next_move(s(0,A,B,C,D,E,F,G,H),s(C,A,B,0,D,E,F,G,H),(C,up)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(0,A,B,C,D,E,F,G,H),(A,right)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(A,B,0,C,D,E,F,G,H),(B,left)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(A,D,B,C,0,E,F,G,H),(D,up)).
puzzle8_next_move(s(A,B,0,C,D,E,F,G,H),s(A,0,B,C,D,E,F,G,H),(B,right)).
puzzle8_next_move(s(A,B,0,C,D,E,F,G,H),s(A,B,E,C,D,0,F,G,H),(E,up)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(0,B,C,A,D,E,F,G,H),(A,down)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(A,B,C,D,0,E,F,G,H),(D,left)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(A,B,C,F,D,E,0,G,H),(F,up)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,0,C,D,B,E,F,G,H),(B,down)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,0,D,E,F,G,H),(D,right)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,D,E,0,F,G,H),(E,left)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,D,G,E,F,0,H),(G,up)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,0,D,E,C,F,G,H),(C,down)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,C,D,0,E,F,G,H),(E,right)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,C,D,E,H,F,G,0),(H,up)).
puzzle8_next_move(s(A,B,C,D,E,F,0,G,H),s(A,B,C,0,E,F,D,G,H),(D,down)).
puzzle8_next_move(s(A,B,C,D,E,F,0,G,H),s(A,B,C,D,E,F,G,0,H),(G,left)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,0,F,G,E,H),(E,down)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,E,F,0,G,H),(G,right)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,E,F,G,H,0),(H,left)).
puzzle8_next_move(s(A,B,C,D,E,F,G,H,0),s(A,B,C,D,E,0,G,H,F),(F,down)).
puzzle8_next_move(s(A,B,C,D,E,F,G,H,0),s(A,B,C,D,E,F,G,0,H),(H,right)).

run_puzzle8:-
    find_IDS(s(1,2,3,4,0,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),
    detailed_print(R).

/*
?- run_puzzle8.
0 0 move:s(1,2,3,4,0,5,6,7,8)
1 1 5,left:s(1,2,3,4,5,0,6,7,8)
2 2 8,up:s(1,2,3,4,5,8,6,7,0)
3 3 7,right:s(1,2,3,4,5,8,6,0,7)
4 4 6,right:s(1,2,3,4,5,8,0,6,7)
5 5 4,down:s(1,2,3,0,5,8,4,6,7)
6 6 5,left:s(1,2,3,5,0,8,4,6,7)
7 7 6,up:s(1,2,3,5,6,8,4,0,7)
8 8 7,left:s(1,2,3,5,6,8,4,7,0)
9 9 8,down:s(1,2,3,5,6,0,4,7,8)
10 10 6,right:s(1,2,3,5,0,6,4,7,8)
11 11 5,right:s(1,2,3,0,5,6,4,7,8)
12 12 4,up:s(1,2,3,4,5,6,0,7,8)
13 13 7,left:s(1,2,3,4,5,6,7,0,8)
14 14 8,left:s(1,2,3,4,5,6,7,8,0)

% (β)
?- time((run_puzzle8)).
0 0 move:s(1,2,3,4,0,5,6,7,8)
1 1 5,left:s(1,2,3,4,5,0,6,7,8)
2 2 8,up:s(1,2,3,4,5,8,6,7,0)
3 3 7,right:s(1,2,3,4,5,8,6,0,7)
4 4 6,right:s(1,2,3,4,5,8,0,6,7)
5 5 4,down:s(1,2,3,0,5,8,4,6,7)
6 6 5,left:s(1,2,3,5,0,8,4,6,7)
7 7 6,up:s(1,2,3,5,6,8,4,0,7)
8 8 7,left:s(1,2,3,5,6,8,4,7,0)
9 9 8,down:s(1,2,3,5,6,0,4,7,8)
10 10 6,right:s(1,2,3,5,0,6,4,7,8)
11 11 5,right:s(1,2,3,0,5,6,4,7,8)
12 12 4,up:s(1,2,3,4,5,6,0,7,8)
13 13 7,left:s(1,2,3,4,5,6,7,0,8)
14 14 8,left:s(1,2,3,4,5,6,7,8,0)
33,032,495 inferences, 12.981 CPU in 19.374 seconds (67% CPU, 2544644 Lips)

% (γ)
run_puzzle8:-
    find_IDS(s(1,2,0,3,4,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),   % Καθυστερεί πολύ.
    detailed_print(R).

?- time((run_puzzle8)).
Depth = 0
Depth = 1
Depth = 2
Depth = 3
Depth = 4
Depth = 5
Depth = 6
Depth = 7
Depth = 8
Depth = 9
Depth = 10
Depth = 11
Depth = 12
Depth = 13
Depth = 14
Depth = 15
Depth = 16
Depth = 17
Depth = 18
Time limit exceeded

% (δ)
run_puzzle8:-
    find_BFS(s(1,2,0,3,4,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),
    detailed_print(R).

?- time((run_puzzle8)).
474,117,143 inferences, 53.195 CPU in 53.347 seconds (100% CPU, 8912869 Lips)
Stack limit (0.2Gb) exceeded
  Stack sizes: local: 3Kb, global: 0.2Gb, trail: 3Kb
  Stack depth: 54,271, last-call: 100%, Choice points: 15
  In:
    [54,271] lists:append([length:9,268], [length:4], _730)
    [22,681] search_BFS([length:40,858], <compound node/5>)
    [36] run_puzzle8
    [35] system:catch(<compound (:)/2>, _826, <compound (:)/2>)
    [34] system:setup_call_catcher_cleanup(<compound (:)/2>, <compound (:)/2>,
    _868, <compound (:)/2>)
*/
