% askisi_11.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 11: ΑΛΓΟΡΙΘΜΟΙ ΑΝΑΖΗΤΗΣΗΣ ΙΙI
% ------------------------------------------------------------------------------
% Από προηγούμενη άσκηση:
% ------------------------------------------------------------------------------

successor(NODE,SNODE):-
    NODE=node(PathCost, State, Action, Depth, _),
    SNODE=node(SPathCost,SState,SAction,SDepth,SParent),
    problem_specific(Action,State,SAction,SState,Cost),
    SDepth is Depth+1, SPathCost is PathCost+Cost, SParent=NODE.

detailed_print(null).
detailed_print(node(TC,S,M,D,P)):-
    detailed_print(P), write(D), write(' '), write(TC), write(' '),
    write(M), write(':'), write(S), nl.

problem_specific(Action,State,SAction,SState,Cost):-
   puzzle8_ps(Action,State,SAction,SState,Cost).

% Το Πρόβλημα των 8 Πλακιδίων
% initial state: s(1,2,3,4,0,5,6,7,8)    final state: s(1,2,3,4,5,6,7,8,0)

puzzle8_ps(_,State,SAction,SState,Cost):-
    puzzle8_next_move(State,SState,SAction), Cost=1.

puzzle8_next_move(s(0,A,B,C,D,E,F,G,H),s(A,0,B,C,D,E,F,G,H),(A,left)).
puzzle8_next_move(s(0,A,B,C,D,E,F,G,H),s(C,A,B,0,D,E,F,G,H),(C,up)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(0,A,B,C,D,E,F,G,H),(A,right)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(A,B,0,C,D,E,F,G,H),(B,left)).
puzzle8_next_move(s(A,0,B,C,D,E,F,G,H),s(A,D,B,C,0,E,F,G,H),(D,up)).
puzzle8_next_move(s(A,B,0,C,D,E,F,G,H),s(A,0,B,C,D,E,F,G,H),(B,right)).
puzzle8_next_move(s(A,B,0,C,D,E,F,G,H),s(A,B,E,C,D,0,F,G,H),(E,up)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(0,B,C,A,D,E,F,G,H),(A,down)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(A,B,C,D,0,E,F,G,H),(D,left)).
puzzle8_next_move(s(A,B,C,0,D,E,F,G,H),s(A,B,C,F,D,E,0,G,H),(F,up)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,0,C,D,B,E,F,G,H),(B,down)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,0,D,E,F,G,H),(D,right)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,D,E,0,F,G,H),(E,left)).
puzzle8_next_move(s(A,B,C,D,0,E,F,G,H),s(A,B,C,D,G,E,F,0,H),(G,up)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,0,D,E,C,F,G,H),(C,down)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,C,D,0,E,F,G,H),(E,right)).
puzzle8_next_move(s(A,B,C,D,E,0,F,G,H),s(A,B,C,D,E,H,F,G,0),(H,up)).
puzzle8_next_move(s(A,B,C,D,E,F,0,G,H),s(A,B,C,0,E,F,D,G,H),(D,down)).
puzzle8_next_move(s(A,B,C,D,E,F,0,G,H),s(A,B,C,D,E,F,G,0,H),(G,left)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,0,F,G,E,H),(E,down)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,E,F,0,G,H),(G,right)).
puzzle8_next_move(s(A,B,C,D,E,F,G,0,H),s(A,B,C,D,E,F,G,H,0),(H,left)).
puzzle8_next_move(s(A,B,C,D,E,F,G,H,0),s(A,B,C,D,E,0,G,H,F),(F,down)).
puzzle8_next_move(s(A,B,C,D,E,F,G,H,0),s(A,B,C,D,E,F,G,0,H),(H,right)).

% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

% Best First Search
% Καλείται ως: find_BestFS(+State1,+State2,-Node)
search_BestFS([augm(_,G)|_],G):- !.
search_BestFS([augm(_,CurrentNode)|Fringe],GoalNode):-
    findall(SuccNode,successor(CurrentNode,SuccNode),NList),
    augment(NList,ANList), append(Fringe,ANList,NewFringe),
    msort(NewFringe,SNFringe), search_BestFS(SNFringe,GoalNode).
find_BestFS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_BestFS([augm(_,node(0,Initial_State,move,0,null))],GoalNode).

augment([],[]).
augment([H|T],[AH|AT]):-
    H=node(_,State,_,_,_), h(State,Value), AH=augm(Value,H), augment(T,AT).

h(State,Value):- h_puzzle8_manhattan(State,Value).

h_puzzle8_manhattan(s(A,B,C,D,E,F,G,H,I),Result):-
    calc(1,A,D1), calc(2,B,D2), calc(3,C,D3),
    calc(4,D,D4), calc(5,E,D5), calc(6,F,D6),
    calc(7,G,D7), calc(8,H,D8), calc(0,I,D0),
    Result is D1+D2+D3+D4+D5+D6+D7+D8+D0.

calc(X,X,0):- !.
calc(1,X,1):- member(X,[2,4]).
calc(1,X,2):- member(X,[3,5,7]).
calc(1,X,3):- member(X,[6,8]).
calc(1,0,4).
calc(2,X,1):- member(X,[1,3,5]).
calc(2,X,2):- member(X,[4,6,8]).
calc(2,X,3):- member(X,[7,0]).
calc(3,X,1):- member(X,[2,6]).
calc(3,X,2):- member(X,[1,5,0]).
calc(3,X,3):- member(X,[4,8]).
calc(3,7,4).
calc(4,X,1):- member(X,[1,5,7]).
calc(4,X,2):- member(X,[2,6,8]).
calc(4,X,3):- member(X,[3,0]).
calc(5,X,1):- member(X,[2,4,6,8]).
calc(5,X,2):- member(X,[1,3,7,0]).
calc(6,X,1):- member(X,[3,5,0]).
calc(6,X,2):- member(X,[2,4,8]).
calc(6,X,3):- member(X,[1,7]).
calc(7,X,1):- member(X,[4,8]).
calc(7,X,2):- member(X,[1,5,0]).
calc(7,X,3):- member(X,[2,6]).
calc(7,3,4).
calc(8,X,1):- member(X,[7,5,0]).
calc(8,X,2):- member(X,[2,4,6]).
calc(8,X,3):- member(X,[1,3]).
calc(0,X,1):- member(X,[6,8]).
calc(0,X,2):- member(X,[3,5,7]).
calc(0,X,3):- member(X,[2,4]).
calc(0,1,4).

run_puzzle8_BestFS:-
    find_BestFS(s(1,2,3,4,0,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),
    detailed_print(R).

/*
?- find_BestFS(s(1,2,3,5,0,8,4,6,7),s(1,2,3,4,5,6,7,8,0),R), detailed_print(R).
0 0 move:s(1,2,3,5,0,8,4,6,7)
1 1 6,up:s(1,2,3,5,6,8,4,0,7)
2 2 7,left:s(1,2,3,5,6,8,4,7,0)
3 3 8,down:s(1,2,3,5,6,0,4,7,8)
4 4 6,right:s(1,2,3,5,0,6,4,7,8)
5 5 5,right:s(1,2,3,0,5,6,4,7,8)
6 6 4,up:s(1,2,3,4,5,6,0,7,8)
7 7 7,left:s(1,2,3,4,5,6,7,0,8)
8 8 8,left:s(1,2,3,4,5,6,7,8,0)
R = node(8,s(1,2,3,4,5,6,7,8,0),(8,left),8,node(7,s(1,2,3,4,5,6,7,0,8),(7,left),7,node(6,s(1,2,3,4,5,6,0,7,8),(4,up),6,node(5,s(1,2,3,0,5,6,4,7,8),(5,right),5,node(4,s(1,2,3,5,0,6,4,7,8),(6,right),4,node(3,s(1,2,3,5,6,0,4,7,8),(8,down),3,node(2,s(1,2,3,5,6,8,4,7,0),(7,left),2,node(1,s(1,2,3,5,6,8,4,0,7),(6,up),1,node(0,s(1,2,3,5,0,8,4,6,7),move,0,null)))))))))
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

% Best First Search (με μνήμη)
% Καλείται ως: find_BestFMS(+State1,+State2,-Node)
search_BestFMS([augm(_,G)|_],_,G):- !.
search_BestFMS([augm(_,CurrentNode)|Fringe],Visited,GoalNode):-
    findall(SuccNode,successor(CurrentNode,SuccNode),NList),
    filter(NList,Visited,FList),
    augment(FList,ANList),
    append(Fringe,ANList,NewFringe), msort(NewFringe,SNFringe),
    CurrentNode=node(_,CurrState,_,_,_), NewVisited=[CurrState|Visited],
    search_BestFMS(SNFringe,NewVisited,GoalNode).
find_BestFMS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_BestFMS([augm(_,node(0,Initial_State,move,0,null))],[],GoalNode).

filter([],_,[]).
filter([H|T],Visited,FL):-
    H=node(_,State,_,_,_), member(State,Visited), !, filter(T,Visited,FL).
filter([H|T],Visited,[H|FL]):- filter(T,Visited,FL).

run_puzzle8_BestFMS:-
    find_BestFMS(s(1,2,3,4,0,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),
    detailed_print(R).

/*
?- run_puzzle8_BestFMS.
0 0 move:s(1,2,3,4,0,5,6,7,8)
1 1 4,right:s(1,2,3,0,4,5,6,7,8)
2 2 6,up:s(1,2,3,6,4,5,0,7,8)
3 3 7,left:s(1,2,3,6,4,5,7,0,8)
4 4 8,left:s(1,2,3,6,4,5,7,8,0)
5 5 5,down:s(1,2,3,6,4,0,7,8,5)
6 6 4,right:s(1,2,3,6,0,4,7,8,5)
7 7 6,right:s(1,2,3,0,6,4,7,8,5)
8 8 7,up:s(1,2,3,7,6,4,0,8,5)
9 9 8,left:s(1,2,3,7,6,4,8,0,5)
10 10 5,left:s(1,2,3,7,6,4,8,5,0)
11 11 4,down:s(1,2,3,7,6,0,8,5,4)
12 12 6,right:s(1,2,3,7,0,6,8,5,4)
13 13 5,up:s(1,2,3,7,5,6,8,0,4)
14 14 4,left:s(1,2,3,7,5,6,8,4,0)
15 15 6,down:s(1,2,3,7,5,0,8,4,6)
16 16 5,right:s(1,2,3,7,0,5,8,4,6)
17 17 4,up:s(1,2,3,7,4,5,8,0,6)
18 18 8,right:s(1,2,3,7,4,5,0,8,6)
19 19 7,down:s(1,2,3,0,4,5,7,8,6)
20 20 4,left:s(1,2,3,4,0,5,7,8,6)
21 21 5,left:s(1,2,3,4,5,0,7,8,6)
22 22 6,up:s(1,2,3,4,5,6,7,8,0)

?- find_BestFMS(s(1,2,0,3,4,5,6,7,8),s(1,2,3,4,5,6,7,8,0),_R), detailed_print(_R).
0 0 move:s(1,2,0,3,4,5,6,7,8)
1 1 5,up:s(1,2,5,3,4,0,6,7,8)
2 2 4,right:s(1,2,5,3,0,4,6,7,8)
3 3 3,right:s(1,2,5,0,3,4,6,7,8)
4 4 6,up:s(1,2,5,6,3,4,0,7,8)
5 5 7,left:s(1,2,5,6,3,4,7,0,8)
6 6 8,left:s(1,2,5,6,3,4,7,8,0)
7 7 4,down:s(1,2,5,6,3,0,7,8,4)
8 8 3,right:s(1,2,5,6,0,3,7,8,4)
9 9 6,right:s(1,2,5,0,6,3,7,8,4)
10 10 7,up:s(1,2,5,7,6,3,0,8,4)
11 11 8,left:s(1,2,5,7,6,3,8,0,4)
12 12 4,left:s(1,2,5,7,6,3,8,4,0)
13 13 3,down:s(1,2,5,7,6,0,8,4,3)
14 14 6,right:s(1,2,5,7,0,6,8,4,3)
15 15 4,up:s(1,2,5,7,4,6,8,0,3)
16 16 8,right:s(1,2,5,7,4,6,0,8,3)
17 17 7,down:s(1,2,5,0,4,6,7,8,3)
18 18 4,left:s(1,2,5,4,0,6,7,8,3)
19 19 6,left:s(1,2,5,4,6,0,7,8,3)
20 20 5,down:s(1,2,0,4,6,5,7,8,3)
21 21 2,right:s(1,0,2,4,6,5,7,8,3)
22 22 6,up:s(1,6,2,4,0,5,7,8,3)
23 23 5,left:s(1,6,2,4,5,0,7,8,3)
24 24 3,up:s(1,6,2,4,5,3,7,8,0)
25 25 8,right:s(1,6,2,4,5,3,7,0,8)
26 26 5,down:s(1,6,2,4,0,3,7,5,8)
27 27 6,down:s(1,0,2,4,6,3,7,5,8)
28 28 2,left:s(1,2,0,4,6,3,7,5,8)
29 29 3,up:s(1,2,3,4,6,0,7,5,8)
30 30 6,right:s(1,2,3,4,0,6,7,5,8)
31 31 5,up:s(1,2,3,4,5,6,7,0,8)
32 32 8,left:s(1,2,3,4,5,6,7,8,0)
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

/*
% ΠΡΟΣΟΧΗ: Πρέπει να γίνει comment η augment/2 του Ερωτήματος 1 για να τρέξει σωστά αυτή η υλοποίηση.

% A*
% Καλείται ως: find_AstarS(+State1,+State2,-Node)
search_AstarS([augm(_,G)|_],_,G):- !.
search_AstarS([augm(_,CurrentNode)|Fringe],Visited,GoalNode):-
    findall(SuccNode,successor(CurrentNode,SuccNode),NList),
    filter(NList,Visited,FList),
    augment(FList,ANList),
    append(Fringe,ANList,NewFringe), msort(NewFringe,SNFringe),
    CurrentNode=node(_,CurrState,_,_,_), NewVisited=[CurrState|Visited],
    search_AstarS(SNFringe,NewVisited,GoalNode).
find_AstarS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_AstarS([augm(_,node(0,Initial_State,move,0,null))],[],GoalNode).

augment([],[]).
augment([H|T],[AH|AT]):-
    H=node(Cost,State,_,_,_), h(State,Hval), Value is Hval+Cost,
    AH=augm(Value,H), augment(T,AT).
*/

run_puzzle8_AstarS:-
    find_AstarS(s(1,2,3,4,0,5,6,7,8),s(1,2,3,4,5,6,7,8,0),R),
    detailed_print(R).

% Εναλλακτική υλοποίηση με ενσωματωμένες τις filter/3 και augment/2.
search_AstarS([_:G|_],_,G):- !.
search_AstarS([_:CurrentNode|Fringe],Visited,GoalNode):-
    findall(FVAL:SuccNode,(
                           successor(CurrentNode,SuccNode),
                           SuccNode=node(PCost,SuccState,_,_,_),
                           \+member(SuccState,Visited),
                           h(SuccState,HVAL),
                           FVAL is HVAL+PCost
                          ),ANList),
    append(Fringe,ANList,NewFringe), msort(NewFringe,SNFringe),
    CurrentNode=node(_,CurrState,_,_,_),
    search_AstarS(SNFringe,[CurrState|Visited],GoalNode).
find_AstarS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_AstarS([_:node(0,Initial_State,move,0,null)],[],GoalNode).

/*
?- run_puzzle8_AstarS.
0 0 move:s(1,2,3,4,0,5,6,7,8)
1 1 5,left:s(1,2,3,4,5,0,6,7,8)
2 2 8,up:s(1,2,3,4,5,8,6,7,0)
3 3 7,right:s(1,2,3,4,5,8,6,0,7)
4 4 6,right:s(1,2,3,4,5,8,0,6,7)
5 5 4,down:s(1,2,3,0,5,8,4,6,7)
6 6 5,left:s(1,2,3,5,0,8,4,6,7)
7 7 6,up:s(1,2,3,5,6,8,4,0,7)
8 8 7,left:s(1,2,3,5,6,8,4,7,0)
9 9 8,down:s(1,2,3,5,6,0,4,7,8)
10 10 6,right:s(1,2,3,5,0,6,4,7,8)
11 11 5,right:s(1,2,3,0,5,6,4,7,8)
12 12 4,up:s(1,2,3,4,5,6,0,7,8)
13 13 7,left:s(1,2,3,4,5,6,7,0,8)
14 14 8,left:s(1,2,3,4,5,6,7,8,0)

?- find_AstarS(s(1,2,0,3,4,5,6,7,8),s(1,2,3,4,5,6,7,8,0),_R), detailed_print(_R).
0 0 move:s(1,2,0,3,4,5,6,7,8)
1 1 2,right:s(1,0,2,3,4,5,6,7,8)
2 2 4,up:s(1,4,2,3,0,5,6,7,8)
3 3 3,right:s(1,4,2,0,3,5,6,7,8)
4 4 6,up:s(1,4,2,6,3,5,0,7,8)
5 5 7,left:s(1,4,2,6,3,5,7,0,8)
6 6 8,left:s(1,4,2,6,3,5,7,8,0)
7 7 5,down:s(1,4,2,6,3,0,7,8,5)
8 8 3,right:s(1,4,2,6,0,3,7,8,5)
9 9 6,right:s(1,4,2,0,6,3,7,8,5)
10 10 7,up:s(1,4,2,7,6,3,0,8,5)
11 11 8,left:s(1,4,2,7,6,3,8,0,5)
12 12 6,down:s(1,4,2,7,0,3,8,6,5)
13 13 4,down:s(1,0,2,7,4,3,8,6,5)
14 14 2,left:s(1,2,0,7,4,3,8,6,5)
15 15 3,up:s(1,2,3,7,4,0,8,6,5)
16 16 5,up:s(1,2,3,7,4,5,8,6,0)
17 17 6,right:s(1,2,3,7,4,5,8,0,6)
18 18 8,right:s(1,2,3,7,4,5,0,8,6)
19 19 7,down:s(1,2,3,0,4,5,7,8,6)
20 20 4,left:s(1,2,3,4,0,5,7,8,6)
21 21 5,left:s(1,2,3,4,5,0,7,8,6)
22 22 6,up:s(1,2,3,4,5,6,7,8,0)
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

% Για τον κώδικα του ερωτήματος 4 (Κύβος του Rubik) δείτε το ξεχωριστό αρχείο askisi_11_4.pl
