% askisi_11_4.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 11: ΑΛΓΟΡΙΘΜΟΙ ΑΝΑΖΗΤΗΣΗΣ ΙΙI
% ------------------------------------------------------------------------------
% Ερώτημα 11.4: Ο Κύβος του Rubik
% ------------------------------------------------------------------------------
% Από προηγούμενα ερωτήματα ή ασκήσεις:
% ------------------------------------------------------------------------------

successor(NODE,SNODE):-
    NODE=node(PathCost, State, Action, Depth, _),
    SNODE=node(SPathCost,SState,SAction,SDepth,SParent),
    problem_specific(Action,State,SAction,SState,Cost),
    SDepth is Depth+1, SPathCost is PathCost+Cost, SParent=NODE.

detailed_print(null).
detailed_print(node(TC,S,M,D,P)):-
    detailed_print(P), write(D), write(' '), write(TC), write(' '),
    write(M), write(':'), write(S), nl.

search_AstarS([_:G|_],_,G):- !.
search_AstarS([_:CurrentNode|Fringe],Visited,GoalNode):-
    findall(FVAL:SuccNode,(
                           successor(CurrentNode,SuccNode),
                           SuccNode=node(PCost,SuccState,_,_,_),
                           \+member(SuccState,Visited),
                           h(SuccState,HVAL),
                           FVAL is HVAL+PCost
                          ),ANList),
    append(Fringe,ANList,NewFringe), msort(NewFringe,SNFringe),
    CurrentNode=node(_,CurrState,_,_,_),
    search_AstarS(SNFringe,[CurrState|Visited],GoalNode).

search_IDS(CurrentNode,GoalNode,D):-
    search_DLS(CurrentNode,GoalNode,D), !.
search_IDS(CurrentNode,GoalNode,D):-
    NewD is D+1, search_IDS(CurrentNode,GoalNode,NewD).

search_DLS(G,G,_):- !.
search_DLS(CurrentNode,GoalNode,Limit):-
    CurrentNode=node(_,_,_,D,_), D<Limit,
    successor(CurrentNode,SuccNode),
    search_DLS(SuccNode,GoalNode,Limit).

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

% Διόρθωση find_IDS/3 και find_AstarS/3 με αρχική κίνηση (move,move)

find_IDS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_IDS(node(0,Initial_State,(move,move),0,null),GoalNode,0).

find_AstarS(Initial_State,Goal_State,GoalNode):-
    GoalNode=node(_,Goal_State,_,_,_),
    search_AstarS([_:node(0,Initial_State,(move,move),0,null)],[],GoalNode).

/*
% Λύνεται σε 3 κινήσεις:
initial_state(
state(s(d,b,b,d,f,f,r,f,f),s(b,r,r,f,u,u,f,u,u),s(r,l,l,r,l,l,u,u,u),
s(l,l,d,r,r,d,r,r,d),s(f,d,d,f,d,d,f,l,l),s(b,b,u,b,b,u,b,b,l))
).

% Λύνεται σε 4 κινήσεις:
initial_state(
state(s(f,f,b,f,f,u,f,f,b),s(d,d,u,f,u,u,d,d,u),s(r,l,r,r,l,r,r,l,r),
s(l,l,l,r,r,r,l,l,l),s(u,u,d,b,d,d,u,u,d),s(f,b,b,d,b,b,f,b,b))
).

% Λύνεται σε 5 κινήσεις:
initial_state(
state(s(b,b,l,f,f,l,u,u,l),s(u,b,b,u,u,u,r,r,b),s(b,b,d,l,l,d,l,l,f),
s(u,f,d,u,r,r,u,r,r),s(r,r,f,f,d,f,f,d,f),s(l,l,r,d,b,d,d,b,d))
).
*/

% Λύνεται σε 6 κινήσεις:
initial_state(
state(s(f,f,d,f,f,u,r,r,f),s(l,l,l,b,u,u,u,u,f),s(d,r,l,d,l,l,f,f,d),
s(r,r,u,l,r,u,u,d,u),s(b,d,r,d,d,l,d,f,r),s(b,b,b,b,b,b,b,r,l))
).

goal_state(
state(s(f,f,f,f,f,f,f,f,f),  % front
      s(u,u,u,u,u,u,u,u,u),  % up
      s(l,l,l,l,l,l,l,l,l),  % left
      s(r,r,r,r,r,r,r,r,r),  % right
      s(d,d,d,d,d,d,d,d,d),  % down
      s(b,b,b,b,b,b,b,b,b))  % back
).

problem_specific(Action,State,SAction,SState,Cost):-
	rubik_ps(Action,State,SAction,SState,Cost).

rubik_ps(Action,State,SAction,SState,Cost):-
	Cost=1,
	Action=(PrevSide,_),
	rot(Side,Turn,State,SState),
	PrevSide\=Side,
	SAction=(Side,Turn).

%rot(Side,Turn,State,SState)
rot(f,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F7,F4,F1,F8,F5,F2,F9,F6,F3), s(U1,U2,U3,U4,U5,U6,L9,L6,L3),
    s(L1,L2,D1,L4,L5,D2,L7,L8,D3), s(U7,R2,R3,U8,R5,R6,U9,R8,R9),
    s(R7,R4,R1,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9))).
rot(f,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F9,F8,F7,F6,F5,F4,F3,F2,F1), s(U1,U2,U3,U4,U5,U6,D3,D2,D1),
    s(L1,L2,R7,L4,L5,R4,L7,L8,R1), s(L9,R2,R3,L6,R5,R6,L3,R8,R9),
    s(U9,U8,U7,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9))).
rot(f,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F3,F6,F9,F2,F5,F8,F1,F4,F7), s(U1,U2,U3,U4,U5,U6,R1,R4,R7),
    s(L1,L2,U9,L4,L5,U8,L7,L8,U7), s(D3,R2,R3,D2,R5,R6,D1,R8,R9),
    s(L3,L6,L9,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9))).
rot(l,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(U1,F2,F3,U4,F5,F6,U7,F8,F9), s(B9,U2,U3,B6,U5,U6,B3,U8,U9),
    s(L7,L4,L1,L8,L5,L2,L9,L6,L3), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(F1,D2,D3,F4,D5,D6,F7,D8,D9), s(B1,B2,D7,B4,B5,D4,B7,B8,D1))).
rot(l,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(B9,F2,F3,B6,F5,F6,B3,F8,F9), s(D1,U2,U3,D4,U5,U6,D7,U8,U9),
    s(L9,L8,L7,L6,L5,L4,L3,L2,L1), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(U1,D2,D3,U4,D5,D6,U7,D8,D9), s(B1,B2,F7,B4,B5,F4,B7,B8,F1))).
rot(l,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(D1,F2,F3,D4,F5,F6,D7,F8,F9), s(F1,U2,U3,F4,U5,U6,F7,U8,U9),
    s(L3,L6,L9,L2,L5,L8,L1,L4,L7), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(B9,D2,D3,B6,D5,D6,B3,D8,D9), s(B1,B2,U7,B4,B5,U4,B7,B8,U1))).
rot(r,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,D3,F4,F5,D6,F7,F8,D9), s(U1,U2,F3,U4,U5,F6,U7,U8,F9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R7,R4,R1,R8,R5,R2,R9,R6,R3),
    s(D1,D2,B7,D4,D5,B4,D7,D8,B1), s(U9,B2,B3,U6,B5,B6,U3,B8,B9))).
rot(r,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,B7,F4,F5,B4,F7,F8,B1), s(U1,U2,D3,U4,U5,D6,U7,U8,D9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R9,R8,R7,R6,R5,R4,R3,R2,R1),
    s(D1,D2,U3,D4,D5,U6,D7,D8,U9), s(F9,B2,B3,F6,B5,B6,F3,B8,B9))).
rot(r,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,U3,F4,F5,U6,F7,F8,U9), s(U1,U2,B7,U4,U5,B4,U7,U8,B1),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R3,R6,R9,R2,R5,R8,R1,R4,R7),
    s(D1,D2,F3,D4,D5,F6,D7,D8,F9), s(D9,B2,B3,D6,B5,B6,D3,B8,B9))).
rot(b,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(R3,R6,R9,U4,U5,U6,U7,U8,U9),
    s(U3,L2,L3,U2,L5,L6,U1,L8,L9), s(R1,R2,D9,R4,R5,D8,R7,R8,D7),
    s(D1,D2,D3,D4,D5,D6,L1,L4,L7), s(B7,B4,B1,B8,B5,B2,B9,B6,B3))).
rot(b,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(D9,D8,D7,U4,U5,U6,U7,U8,U9),
    s(R9,L2,L3,R6,L5,L6,R3,L8,L9), s(R1,R2,L7,R4,R5,L4,R7,R8,L1),
    s(D1,D2,D3,D4,D5,D6,U3,U2,U1), s(B9,B8,B7,B6,B5,B4,B3,B2,B1))).
rot(b,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(L7,L4,L1,U4,U5,U6,U7,U8,U9),
    s(D7,L2,L3,D8,L5,L6,D9,L8,L9), s(R1,R2,U1,R4,R5,U2,R7,R8,U3),
    s(D1,D2,D3,D4,D5,D6,R9,R6,R3), s(B3,B6,B9,B2,B5,B8,B1,B4,B7))).
rot(u,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(R1,R2,R3,F4,F5,F6,F7,F8,F9), s(U7,U4,U1,U8,U5,U2,U9,U6,U3),
    s(F1,F2,F3,L4,L5,L6,L7,L8,L9), s(B1,B2,B3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(L1,L2,L3,B4,B5,B6,B7,B8,B9))).
rot(u,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(B1,B2,B3,F4,F5,F6,F7,F8,F9), s(U9,U8,U7,U6,U5,U4,U3,U2,U1),
    s(R1,R2,R3,L4,L5,L6,L7,L8,L9), s(L1,L2,L3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(F1,F2,F3,B4,B5,B6,B7,B8,B9))).
rot(u,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(L1,L2,L3,F4,F5,F6,F7,F8,F9), s(U3,U6,U9,U2,U5,U8,U1,U4,U7),
    s(B1,B2,B3,L4,L5,L6,L7,L8,L9), s(F1,F2,F3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(R1,R2,R3,B4,B5,B6,B7,B8,B9))).
rot(d,c,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,L7,L8,L9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,B7,B8,B9), s(R1,R2,R3,R4,R5,R6,F7,F8,F9),
    s(D7,D4,D1,D8,D5,D2,D9,D6,D3), s(B1,B2,B3,B4,B5,B6,R7,R8,R9))).
rot(d,h,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,B7,B8,B9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,R7,R8,R9), s(R1,R2,R3,R4,R5,R6,L7,L8,L9),
    s(D9,D8,D7,D6,D5,D4,D3,D2,D1), s(B1,B2,B3,B4,B5,B6,F7,F8,F9))).
rot(d,a,state(s(F1,F2,F3,F4,F5,F6,F7,F8,F9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,L7,L8,L9), s(R1,R2,R3,R4,R5,R6,R7,R8,R9),
    s(D1,D2,D3,D4,D5,D6,D7,D8,D9), s(B1,B2,B3,B4,B5,B6,B7,B8,B9)),
    state(s(F1,F2,F3,F4,F5,F6,R7,R8,R9), s(U1,U2,U3,U4,U5,U6,U7,U8,U9),
    s(L1,L2,L3,L4,L5,L6,F7,F8,F9), s(R1,R2,R3,R4,R5,R6,B7,B8,B9),
    s(D3,D6,D9,D2,D5,D8,D1,D4,D7), s(B1,B2,B3,B4,B5,B6,L7,L8,L9))).

%h(State,Value):- h_rubik1(State,Value).
h(State,Value):- h_rubik2(State,Value).

h_rubik1(State,Score):-
    State=..[_|S],
    findall(C, (member(E,S),count_side(E,C)), LC),
    sumlist(LC,Score1), Score is Score1/12.

h_rubik2(State,Score):-
    State=..[_|S],
    findall(C, (member(E,S),count_side(E,C)), LC),
    sumlist(LC,Score1),
    count_all_side_conflicts(S,Score2),
    Score is (Score1+Score2)/12.

count_side(s(S1,S2,S3,S4,S5,S6,S7,S8,S9),Count):-
    findall(X, (member(X,[S1,S2,S3,S4,S6,S7,S8,S9]),X=S5), L),
    length(L,CN), Count is 8-CN.

count_one_side_conflicts(Side,Count):-
    side_conflicts(SC),
    findall(X, (member(X,SC),X=Side), PC),
    length(PC,Count).

count_all_side_conflicts(SL,Score):-
    findall(C, (member(Side,SL),count_one_side_conflicts(Side,C)), CL),
    sumlist(CL,Score).

side_conflicts([
s(_,u,_,_,f,_,_,_,_),s(_,d,_,_,f,_,_,_,_),
s(_,_,_,_,f,_,_,u,_),s(_,_,_,_,f,_,_,d,_),
s(_,_,_,l,f,_,_,_,_),s(_,_,_,r,f,_,_,_,_),
s(_,_,_,_,f,l,_,_,_),s(_,_,_,_,f,r,_,_,_),
s(_,f,_,_,u,_,_,_,_),s(_,b,_,_,u,_,_,_,_),
s(_,_,_,_,u,_,_,f,_),s(_,_,_,_,u,_,_,b,_),
s(_,_,_,l,u,_,_,_,_),s(_,_,_,r,u,_,_,_,_),
s(_,_,_,_,u,l,_,_,_),s(_,_,_,_,u,r,_,_,_),
s(_,u,_,_,l,_,_,_,_),s(_,d,_,_,l,_,_,_,_),
s(_,_,_,_,l,_,_,u,_),s(_,_,_,_,l,_,_,d,_),
s(_,_,_,f,l,_,_,_,_),s(_,_,_,b,l,_,_,_,_),
s(_,_,_,_,l,f,_,_,_),s(_,_,_,_,l,b,_,_,_),
s(_,u,_,_,r,_,_,_,_),s(_,d,_,_,r,_,_,_,_),
s(_,_,_,_,r,_,_,u,_),s(_,_,_,_,r,_,_,d,_),
s(_,_,_,f,r,_,_,_,_),s(_,_,_,b,r,_,_,_,_),
s(_,_,_,_,r,f,_,_,_),s(_,_,_,_,r,b,_,_,_),
s(_,f,_,_,d,_,_,_,_),s(_,b,_,_,d,_,_,_,_),
s(_,_,_,_,d,_,_,f,_),s(_,_,_,_,d,_,_,b,_),
s(_,_,_,l,d,_,_,_,_),s(_,_,_,r,d,_,_,_,_),
s(_,_,_,_,d,l,_,_,_),s(_,_,_,_,d,r,_,_,_),
s(_,u,_,_,b,_,_,_,_),s(_,d,_,_,b,_,_,_,_),
s(_,_,_,_,b,_,_,u,_),s(_,_,_,_,b,_,_,d,_),
s(_,_,_,l,b,_,_,_,_),s(_,_,_,r,b,_,_,_,_),
s(_,_,_,_,b,l,_,_,_),s(_,_,_,_,b,r,_,_,_)]).

run_rubik:- initial_state(I), goal_state(G),
    %find_IDS(I,G,R),   % επιλογή αλγορίθμου
    find_AstarS(I,G,R),
    detailed_print(R).

/*
?- run_rubik.
0 0 null,null:state(s(f,f,d,f,f,u,r,r,f),s(l,l,l,b,u,u,u,u,f),s(d,r,l,d,l,l,f,f,d),
    s(r,r,u,l,r,u,u,d,u),s(b,d,r,d,d,l,d,f,r),s(b,b,b,b,b,b,b,r,l))
1 1 d,c:state(s(f,f,d,f,f,u,f,f,d),s(l,l,l,b,u,u,u,u,f),s(d,r,l,d,l,l,b,r,l),
    s(r,r,u,l,r,u,r,r,f),s(d,d,b,f,d,d,r,l,r),s(b,b,b,b,b,b,u,d,u))
2 2 f,h:state(s(d,f,f,u,f,f,d,f,f),s(l,l,l,b,u,u,b,d,d),s(d,r,r,d,l,l,b,r,r),
    s(l,r,u,l,r,u,l,r,f),s(f,u,u,f,d,d,r,l,r),s(b,b,b,b,b,b,u,d,u))
3 3 b,a:state(s(d,f,f,u,f,f,d,f,f),s(b,d,d,b,u,u,b,d,d),s(r,r,r,l,l,l,r,r,r),
    s(l,r,l,l,r,l,l,r,l),s(f,u,u,f,d,d,f,u,u),s(b,b,u,b,b,d,b,b,u))
4 4 l,a:state(s(f,f,f,f,f,f,f,f,f),s(d,d,d,u,u,u,d,d,d),s(r,l,r,r,l,r,r,l,r),
    s(l,r,l,l,r,l,l,r,l),s(u,u,u,d,d,d,u,u,u),s(b,b,b,b,b,b,b,b,b))
5 5 f,h:state(s(f,f,f,f,f,f,f,f,f),s(d,d,d,u,u,u,u,u,u),s(r,l,l,r,l,l,r,l,l),
    s(r,r,l,r,r,l,r,r,l),s(d,d,d,d,d,d,u,u,u),s(b,b,b,b,b,b,b,b,b))
6 6 b,h:state(s(f,f,f,f,f,f,f,f,f),s(u,u,u,u,u,u,u,u,u),s(l,l,l,l,l,l,l,l,l),
    s(r,r,r,r,r,r,r,r,r),s(d,d,d,d,d,d,d,d,d),s(b,b,b,b,b,b,b,b,b))
*/

shuffle(0,FinalState,FinalState):- !.
shuffle(N,CubeState,FinalState):-
    random_member(Side,[f,u,l,r,d,b]), random_member(Turn,[c,h,a]),
    rot(Side,Turn,CubeState,NextState),
    write((Side,Turn)), write(" h="),
    h(NextState,Score), write(Score), nl,
    N1 is N-1, shuffle(N1,NextState,FinalState).

shuffle_init(N,ShuffledCube):- goal_state(G), shuffle(N,G,ShuffledCube).

run_rubik_shuffled(N):- shuffle_init(N,I), goal_state(G),
	%find_IDS(I,G,R),   % επιλογή αλγορίθμου
	find_AstarS(I,G,R),
	detailed_print(R).

/*
?- run_rubik_shuffled(6).
l,c h=1
d,a h=1.9166666666666667
r,a h=2.75
d,h h=2.9166666666666665
b,a h=3.5
l,h h=3.5
0 0 null,null:state(s(r,f,u,r,f,u,u,l,l),s(r,l,l,f,u,b,f,u,b),s(b,r,d,l,l,d,l,l,f),
    s(r,r,b,r,r,u,u,f,l),s(r,f,f,b,d,d,b,b,d),s(d,d,d,b,b,u,f,d,u))
1 1 l,h:state(s(u,f,u,u,f,u,d,l,l),s(r,l,l,b,u,b,b,u,b),s(f,l,l,d,l,l,d,r,b),
    s(r,r,b,r,r,u,u,f,l),s(r,f,f,f,d,d,f,b,d),s(d,d,u,b,b,r,f,d,r))
2 2 b,c:state(s(u,f,u,u,f,u,d,l,l),s(b,u,l,b,u,b,b,u,b),s(l,l,l,l,l,l,r,r,b),
    s(r,r,d,r,r,b,u,f,f),s(r,f,f,f,d,d,f,d,d),s(f,b,d,d,b,d,r,r,u))
3 3 d,h:state(s(u,f,u,u,f,u,r,r,u),s(b,u,l,b,u,b,b,u,b),s(l,l,l,l,l,l,u,f,f),
    s(r,r,d,r,r,b,r,r,b),s(d,d,f,d,d,f,f,f,r),s(f,b,d,d,b,d,d,l,l))
4 4 r,c:state(s(u,f,f,u,f,f,r,r,r),s(b,u,u,b,u,u,b,u,u),s(l,l,l,l,l,l,u,f,f),
    s(r,r,r,r,r,r,b,b,d),s(d,d,d,d,d,d,f,f,f),s(b,b,d,b,b,d,l,l,l))
5 5 d,c:state(s(u,f,f,u,f,f,u,f,f),s(b,u,u,b,u,u,b,u,u),s(l,l,l,l,l,l,l,l,l),
    s(r,r,r,r,r,r,r,r,r),s(f,d,d,f,d,d,f,d,d),s(b,b,d,b,b,d,b,b,d))
6 6 l,a:state(s(f,f,f,f,f,f,f,f,f),s(u,u,u,u,u,u,u,u,u),s(l,l,l,l,l,l,l,l,l),
    s(r,r,r,r,r,r,r,r,r),s(d,d,d,d,d,d,d,d,d),s(b,b,b,b,b,b,b,b,b))
*/
