% askisi_12.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 12: ΑΝΑΖΗΤΗΣΗ ΜΕ ΑΝΤΙΠΑΛΟΤΗΤΑ
% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

% Αν τρέξετε τον κώδικα στο https://swish.swi-prolog.org/ υπάρχει περίπτωση
% να μη σας δίνει άδεια να εκτελέσετε εντολές assert και retract.
% Σε αυτήν την περίπτωση δοκιμάστε στο https://wasm.swi-prolog.org/wasm/shell
% ή σε εγκατεστημένη στον υπολογιστή σας έκδοση της Prolog.

:- dynamic inKB/2.    % Ορισμός δυναμικής Βάσης Γνώσης (KB).
                                 % inKB(+Position,?Result)

% utility(+Position,-Result)
% Δέχεται μια θέση/κατάσταση και επιστρέφει τον χαρακτηρισμό της: win,draw,lose
utility(Position,X):- inKB(Position,X), !. % Αν o χαρακτηρισμός βρεθεί στην KB,
                                          % ..χρησιμοποιείται απευθείας.
utility(Position,X):-
    findall(                         % Αλλιώς βρίσκουμε όλες..
        (NextPosition,NextX),
        (successor(Position,NextPosition), % ..τις διάδοχες θέσεις,
        utility(NextPosition,NextX)), % ..υπολογίζουμε αναδρομικά τα utilities τους
        NUTILSmult),          % ..και τα συγκεντρώνουμε σε μια λίστα πλειάδων.
    sort(NUTILSmult,NUTILS),  % Διαγράφουμε τυχόν διπλές πλειάδες.
    estimate(NUTILS,X),       % Υπολογίζουμε τον χαρακτηρισμό της αρχικής θέσης
    asserta(inKB(Position,X)).   % ..και τον προσθέτουμε στην KB.

% estimate(+LIST,-Result)
% Αν υπάρχει έστω μία χαμένη θέση στη λίστα, η αρχική θέση είναι κερδισμένη.
% Αλλιώς, αν υπάρχει έστω και μία ισόπαλη θέση, η αρχική είναι ισόπαλη.
% Αλλιώς η αρχική είναι χαμένη.
estimate(NUTILS,win):- member((_,lose),NUTILS), !.
estimate(NUTILS,draw):- member((_,draw),NUTILS), !.
estimate(_,lose).

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

% Κανόνες NIM
% Αρχική θέση: [3,5,7]

inKB([1],lose).  % Ο παίκτης που σβήνει το τελευταίο στοιχείο χάνει.
inKB([],win).

% successor(+Position,-NextPosition)
% Επιστρέφει μη ντετερμινιστικά όλες τις διάδοχες θέσεις από μια αρχική.
successor([],[]):- !, fail.      % Χωρίς στοιχεία το παιχνίδι τελειώνει.
successor([N],[Q]):-                             % Ο παίκτης μπορεί να σβήσει..
    NS is N-1, enlist(NS,AllNS), member(Q,AllNS).% ..ένα ή περισσότερα στοιχεία,
successor([_],[]).                               % ..ή και ολόκληρη ομάδα.
successor([N],[L,R]):-                       % Μια ομάδα μπορεί να σπάσει σε δύο
    N>2,                                     % ..αν έχει πάνω από 2 στοιχεία.
    NReduced is N-2,            % Η κάθε νέα ομάδα θα έχει το πολύ N-2 στοιχεία
                                % ..(1 που αφαιρέσαμε +1 min για την άλλη ομάδα)
    enlist(NReduced,LN),
    member(L,LN), member(M,LN), member(R,LN), % Όλες οι δυνατές τιμές των L,M,R
    L=<R, N =:= L+M+R.                        % ..φιλτράρονται από τις συνθήκες.
successor(Lin,Lout):-
    length(Lin,LEN), LEN>1,     % Αν η θέση έχει πάνω από 1 ομάδα,
    remove(X,Lin,LmX),          % ..επιλέγουμε μία,
    successor([X],SX),          % ..βρίσκουμε την διάδοχη ομάδα,
    append(LmX,SX,LoutNS),      % ..και την αντικαθιστούμε στη θέση.
    msort(LoutNS,Lout).         % Ταξινομούμε τις ομάδες.

remove(X,Lin,Lout):- append(A,[X|B],Lin), append(A,B,Lout).

enlist(0,[]):- !.
enlist(X,[X|T]):- Y is X-1, enlist(Y,T).

/*
?- utility([2,2,2],U).
U = win

?- listing(inKB).
inKB([2, 2, 2], win).
inKB([1, 2, 2], win).
inKB([1, 1, 2], win).
inKB([1, 1, 1], lose).
inKB([2, 2], lose).
inKB([1, 2], win).
inKB([1, 1], win).
inKB([2], win).
inKB([1], lose).
inKB([], win).

?- utility([3,3],U).
U = lose

?- listing(inKB).
inKB([3, 3], lose).
inKB([1, 1, 3], win).
inKB([1, 1, 1, 1], win).
inKB([2, 3], win).
inKB([1, 1, 2], win).
inKB([2, 2], lose).
inKB([1, 3], win).
inKB([1, 1, 1], lose).
inKB([1, 2], win).
inKB([3], win).
inKB([1, 1], win).
inKB([2], win).
inKB([1], lose).
inKB([], win).

?- utility([3,5,7],U).
U = win

?- listing(inKB).
inKB([3, 5, 7], win).
inKB([1, 3, 5, 5], win).
inKB([2, 3, 4, 5], lose).
inKB([3, 3, 3, 5], win).
...
inKB([1, 1], win).
inKB([2], win).
inKB([1], lose).
inKB([], win).

?- utility([2,4,6],U).
U = lose

?- listing(inKB).
inKB([2, 4, 6], lose).
inKB([1, 2, 4, 4], win).
inKB([2, 2, 3, 4], win).
inKB([2, 4, 5], win).
...
inKB([1, 1], win).
inKB([2], win).
inKB([1], lose).
inKB([], win).

?- utility([2,4,6,8],U).
U = win

?- listing(inKB).
inKB([2, 4, 6, 8], win).
inKB([1, 2, 4, 6, 6], win).
inKB([2, 2, 4, 5, 6], win).
inKB([2, 2, 2, 2, 4, 6], win).
...
inKB([1, 1], win).
inKB([2], win).
inKB([1], lose).
inKB([], win).
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

play(Position,NewPosition):-
    findall((NextPosition,NextX),
        (successor(Position,NextPosition),utility(NextPosition,NextX)), NUTILSmult),
        select_position(NUTILSmult,(NewPosition,Result)),
        message(Position,NewPosition,Result).
select_position(List,Position):- member(Position,List),Position=(_,lose), !.
select_position(List,Position):- member(Position,List),Position=(_,draw), !.
select_position(List,Position):- member(Position,List), !.

message(From,To,Result):-
    write(From), write(' --> '), write(To), write('   '), write(Result), nl.

/*
?- play([2,4,6],NewState).
[2, 4, 6] --> [1, 4, 6] win
NewState = [1, 4, 6]

?- play([3,5,7],NewState).
[3, 5, 7] --> [2, 5, 7] lose
NewState = [2, 5, 7]
*/

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

perfect_game(Position):- play(Position,NewPosition), perfect_game(NewPosition).

/*
?- perfect_game([3,5,7]).
[3,5,7] --> [2,5,7]   lose
[2,5,7] --> [1,5,7]   win
[1,5,7] --> [1,4,5]   lose
[1,4,5] --> [4,5]   win
[4,5] --> [4,4]   lose
[4,4] --> [3,4]   win
[3,4] --> [3,3]   lose
[3,3] --> [2,3]   win
[2,3] --> [2,2]   lose
[2,2] --> [1,2]   win
[1,2] --> [1]   lose
[1] --> []   win
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

/*
% ΠΡΟΣΟΧΗ: Πρέπει να γίνει comment το Ερώτημα 2 για να τρέξουν αυτοί οι κανόνες.

% Κανόνες Τρίλιζας
% Αρχική Θέση: ([0,0,0,0,0,0,0,0,0],1)

inKB((State,P),lose):- is_triliza(State,R), R =:= -P.
inKB((State,_),draw):- \+member(0,State), \+is_triliza(State,_).

% is_triliza(+L,-Who)
is_triliza([P,P,P,_,_,_,_,_,_],P):- !.
is_triliza([_,_,_,P,P,P,_,_,_],P):- !.
is_triliza([_,_,_,_,_,_,P,P,P],P):- !.
is_triliza([P,_,_,P,_,_,P,_,_],P):- !.
is_triliza([_,P,_,_,P,_,_,P,_],P):- !.
is_triliza([_,_,P,_,_,P,_,_,P],P):- !.
is_triliza([P,_,_,_,P,_,_,_,P],P):- !.
is_triliza([_,_,P,_,P,_,P,_,_],P):- !.

successor((State,Who),(NewState,Other)):-
    replace(0,Who,State,NewState), Other is -Who.

replace(X,Y,Lin,Lout):- append(A,[X|B],Lin), append(A,[Y|B],Lout).
*/

% ------------------------------------------------------------------------------
% Ερώτημα 6
% ------------------------------------------------------------------------------

/*
?- utility(([0,0,0,0,0,0,0,0,0],1),U).
U = draw

?- play(([0,0,0,0,0,0,0,0,0],1),W).
[0,0,0,0,0,0,0,0,0],1 --> [1,0,0,0,0,0,0,0,0],-1   draw
W = ([1, 0, 0, 0, 0, 0, 0, 0|...], -1)

?- perfect_game(([0,0,0,0,0,0,0,0,0],1)).
[0,0,0,0,0,0,0,0,0],1 --> [1,0,0,0,0,0,0,0,0],-1   draw
[1,0,0,0,0,0,0,0,0],-1 --> [1,0,0,0,-1,0,0,0,0],1   draw
[1,0,0,0,-1,0,0,0,0],1 --> [1,1,0,0,-1,0,0,0,0],-1   draw
[1,1,0,0,-1,0,0,0,0],-1 --> [1,1,-1,0,-1,0,0,0,0],1   draw
[1,1,-1,0,-1,0,0,0,0],1 --> [1,1,-1,0,-1,0,1,0,0],-1   draw
[1,1,-1,0,-1,0,1,0,0],-1 --> [1,1,-1,-1,-1,0,1,0,0],1   draw
[1,1,-1,-1,-1,0,1,0,0],1 --> [1,1,-1,-1,-1,1,1,0,0],-1   draw
[1,1,-1,-1,-1,1,1,0,0],-1 --> [1,1,-1,-1,-1,1,1,-1,0],1   draw
[1,1,-1,-1,-1,1,1,-1,0],1 --> [1,1,-1,-1,-1,1,1,-1,1],-1   draw
*/
