% askisi_13.pl (Encoding: UTF-8)
% Εργαστηριακές Ασκήσεις Τεχνητής Νοημοσύνης με τη Γλώσσα Prolog
% Κυριάκος Σγάρμπας
% 2024, Κάλλιπος, Ανοικτές Ακαδημαϊκές Εκδόσεις
% ------------------------------------------------------------------------------
% ΑΣΚΗΣΗ 13: ΑΛΓΟΡΙΘΜΟΙ MINIMAX ΚΑΙ ALPHA-BETA PRUNING
% ------------------------------------------------------------------------------
% Ερώτημα 1
% ------------------------------------------------------------------------------

game_over((State,-1)):- First5=[_,_,_,_,_], append(First5,_,State),
    member(1,First5), !.
game_over((State,1)):- Last5=[_,_,_,_,_], append(_,Last5,State),
    member(-1,Last5).

successor(Pos,_):- game_over(Pos), !, fail.
successor((State,1),(NewState,-1)):-
    append(BeforePawn,[1|AfterPawn],State),
    append(BeforeTarget,[0|AfterTarget],BeforePawn),
    length(AfterTarget,4),
    append(BeforeTarget,[1|AfterTarget],NewBeforePawn),
    append(NewBeforePawn,[0|AfterPawn],NewState).
successor((State,1),(NewState,-1)):-
    append(BeforePawn,[1|AfterPawn],State),
    length(BeforePawn,LBP), LBP mod 5 =\= 0,
    append(BeforeTarget,[-1|AfterTarget],BeforePawn),
    length(AfterTarget,5),
    append(BeforeTarget,[1|AfterTarget],NewBeforePawn),
    append(NewBeforePawn,[0|AfterPawn],NewState).
successor((State,1),(NewState,-1)):-
    append(BeforePawn,[1|AfterPawn],State),
    length(BeforePawn,LBP), LBP mod 5 =\= 4,
    append(BeforeTarget,[-1|AfterTarget],BeforePawn),
    length(AfterTarget,3),
    append(BeforeTarget,[1|AfterTarget],NewBeforePawn),
    append(NewBeforePawn,[0|AfterPawn],NewState).
successor((State,-1),(NewState,1)):-
    append(BeforePawn,[-1|AfterPawn],State),
    append(BeforeTarget,[0|AfterTarget],AfterPawn),
    length(BeforeTarget,4),
    append(BeforeTarget,[-1|AfterTarget],NewAfterPawn),
    append(BeforePawn,[0|NewAfterPawn],NewState).
successor((State,-1),(NewState,1)):-
    append(BeforePawn,[-1|AfterPawn],State),
    length(BeforePawn,LBP), LBP mod 5 =\= 0,
    append(BeforeTarget,[1|AfterTarget],AfterPawn),
    length(BeforeTarget,3),
    append(BeforeTarget,[-1|AfterTarget],NewAfterPawn),
    append(BeforePawn,[0|NewAfterPawn],NewState).
successor((State,-1),(NewState,1)):-
    append(BeforePawn,[-1|AfterPawn],State),
    length(BeforePawn,LBP), LBP mod 5 =\= 4,
    append(BeforeTarget,[1|AfterTarget],AfterPawn),
    length(BeforeTarget,5),
    append(BeforeTarget,[-1|AfterTarget],NewAfterPawn),
    append(BeforePawn,[0|NewAfterPawn],NewState).

/*
?- successor(([-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1),N).
N = ([-1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1],-1)
N = ([-1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1],-1)
N = ([-1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 1],-1)
N = ([-1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1],-1)
N = ([-1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0],-1)

?- successor(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N).
N = ([0, -1, 0, 0, -1, 0, 1, 0, 0, 0, -1, 0, -1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0],-1)
N = ([0, -1, 0, 0, -1, 0, 1, 0, 0, 0, -1, 0, -1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0],-1)
N = ([0, -1, 0, 0, -1, 0, 1, 0, 0, 0, -1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0],-1)

?- successor(([0,1,0,0,0,0,0,-1,0,-1,-1,0,0,0,0,0,0,0,0,0,1,0,0,0,0],-1),N).
false
*/

% ------------------------------------------------------------------------------
% Ερώτημα 2
% ------------------------------------------------------------------------------

:- dynamic inKB/2.

inKB(Pos,lose):- game_over(Pos).

% utility(+State,-Result)
utility(State,X):- inKB(State,X), !.
utility(State,X):-
    findall((NextState,NextX),
        (successor(State,NextState), utility(NextState,NextX)),
        NUTILSmult),
    sort(NUTILSmult,NUTILS),
    estimate(NUTILS,X),
    asserta(inKB(State,X)).

% estimate(+LIST,-Result)
estimate(NUTILS,win):- member((_,lose),NUTILS), !.
estimate(NUTILS,draw):- member((_,draw),NUTILS), !.
estimate(_,lose).

/*
?- utility(([-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1),U).
Time limit exceeded

?- utility(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),U).
U = win

?- utility(([0,1,0,0,0,0,0,-1,0,-1,-1,0,0,0,0,0,0,0,0,0,1,0,0,0,0],-1),U).
U = lose
*/

% ------------------------------------------------------------------------------
% Ερώτημα 3
% ------------------------------------------------------------------------------

% evaluate(+Position, ‐Value)
evaluate((State,_),Value):- coeff(CF), eval(State,CF,Value).

eval([],[],0).
eval([H|State],[C|CF],VSum):- sqval(H,C,V),
    eval(State,CF,VS2), VSum is V+VS2.

sqval(0,_,0):- !.
sqval(1,C,C):- !.
sqval(-1,C,R):- R is C-6.

coeff([5,5,5,5,5,4,4,4,4,4,3,3,3,3,3,2,2,2,2,2,1,1,1,1,1]).

% ------------------------------------------------------------------------------
% Ερώτημα 4
% ------------------------------------------------------------------------------

%minimax(+Pos, +Depth, ‐Value)
minimax(Pos,_,Value):- game_over(Pos), !, Pos=(_,Player),
    Value is -Player*100.
minimax(Pos,0,Value):- evaluate(Pos,Value), !.
minimax(Pos,Depth,Value):-
    NDepth is Depth-1,
    findall(Vi,
            (successor(Pos,NewPos), minimax(NewPos,NDepth,Vi)),
            LVi),
    Pos=(_,Player),
    minmax_list(Player,LVi,Value).

minmax_list(1,L,Value):- max_list(L,Value).
minmax_list(-1,L,Value):- min_list(L,Value).

% ------------------------------------------------------------------------------
% Ερώτημα 5
% ------------------------------------------------------------------------------

% alphabeta(+Pos,+Depth, +A, +B, ‐Value)
alphabeta(Pos,_,_,_,Value):- game_over(Pos), !, Pos=(_,Player),
    Value is -Player*100.
alphabeta(Pos,0,_,_,Value):- evaluate(Pos,Value), !.
alphabeta(Pos,Depth,A,B,Value):-
    Pos=(_,Player), NDepth is Depth-1,
    findall(NewPos, successor(Pos,NewPos), LNewPos),
    get_value(Player,LNewPos,NDepth,A,B,Value).

get_value(1,[],_,A,_,A):- !.
get_value(1,[Pos|RestPos],Depth,A,B,BestValue):-
    alphabeta(Pos,Depth,A,B,Value),
    AValue is max(A,Value),
    checkB(RestPos,Depth,AValue,B,BestValue).
get_value(-1,[],_,_,B,B):- !.
get_value(-1,[Pos|RestPos],Depth,A,B,BestValue):-
    alphabeta(Pos,Depth,A,B,Value),
    BValue is min(B,Value),
    checkA(RestPos,Depth,A,BValue,BestValue).

checkA(_,_,A,BValue,BValue):- BValue < A, !.
checkA(RestPos,Depth,A,BValue,BestValue):-
    get_value(-1,RestPos,Depth,A,BValue,BestValue).

checkB(_,_,AValue,B,AValue):- AValue > B, !.
checkB(RestPos,Depth,AValue,B,BestValue):-
    get_value(1,RestPos,Depth,AValue,B,BestValue).

% ------------------------------------------------------------------------------
% Ερώτημα 6
% ------------------------------------------------------------------------------

%play(+Pos, ‐NewPos, +Depth)
play(Pos,NewPos,Depth):-
    findall((Value,NextPos),
        (successor(Pos,NextPos),
         select_algorithm(NextPos,Depth,Value)),
            NSList),
    Pos=(_,Player),
    select_best(NSList,Player,(Eval,NewPos)),
    message(Pos,NewPos,Eval).

select_algorithm(P,D,V):-
    minimax(P,D,V).
    % alphabeta(P,D,-1000,1000,V).

select_best(PosList,Player,Pos):-
    msort(PosList,SortedPosList),
    reverse_or_not(Player,SortedPosList,[Pos|_]).

reverse_or_not(-1,L,L).
reverse_or_not(1,L,R):- reverse(L,R).

message(From,To,Result):-
    write(From), write(' --> '), write(To), write('   '), write(Result), nl.

/*
?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,0).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   3
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,1).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   2
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,2).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   3
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,3).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   -2
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,4).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   100
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,5).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   100
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)

?- play(([0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1),N,6).
[0,-1,0,0,-1,0,1,0,0,0,-1,0,-1,0,0,0,0,0,1,0,1,0,0,0,0],1 --> [0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1   100
N = ([0,-1,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,0,0,1,0,0,0,0],-1)
*/

% ------------------------------------------------------------------------------
% Ερώτημα 7
% ------------------------------------------------------------------------------

%full_game(+Pos, +Depth)
full_game(Pos,Depth):- play(Pos,NewPos,Depth), full_game(NewPos,Depth).

/*
?- full_game(([-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1),6).
[-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1 --> [-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],-1   1
[-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],-1 --> [-1,-1,-1,-1,0,0,0,0,0,-1,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],1   0
[-1,-1,-1,-1,0,0,0,0,0,-1,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],1 --> [-1,-1,-1,-1,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1],-1   1
[-1,-1,-1,-1,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1],-1 --> [-1,-1,-1,0,0,0,0,0,-1,-1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1],1   -2
[-1,-1,-1,0,0,0,0,0,-1,-1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1],1 --> [-1,-1,-1,0,0,0,0,0,-1,-1,1,0,0,0,0,0,1,0,0,0,0,0,1,1,1],-1   1
[-1,-1,-1,0,0,0,0,0,-1,-1,1,0,0,0,0,0,1,0,0,0,0,0,1,1,1],-1 --> [-1,-1,-1,0,0,0,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,1,1,1],1   -1
[-1,-1,-1,0,0,0,0,0,-1,0,1,0,0,0,-1,0,1,0,0,0,0,0,1,1,1],1 --> [-1,-1,-1,0,0,0,0,0,-1,0,1,1,0,0,-1,0,0,0,0,0,0,0,1,1,1],-1   1
[-1,-1,-1,0,0,0,0,0,-1,0,1,1,0,0,-1,0,0,0,0,0,0,0,1,1,1],-1 --> [-1,-1,-1,0,0,0,0,0,0,0,1,1,0,-1,-1,0,0,0,0,0,0,0,1,1,1],1   -2
[-1,-1,-1,0,0,0,0,0,0,0,1,1,0,-1,-1,0,0,0,0,0,0,0,1,1,1],1 --> [-1,-1,-1,0,0,0,0,0,0,0,1,1,0,-1,-1,0,0,0,0,1,0,0,1,1,0],-1   3
[-1,-1,-1,0,0,0,0,0,0,0,1,1,0,-1,-1,0,0,0,0,1,0,0,1,1,0],-1 --> [-1,-1,-1,0,0,0,0,0,0,0,1,1,0,0,-1,0,0,0,-1,1,0,0,1,1,0],1   0
[-1,-1,-1,0,0,0,0,0,0,0,1,1,0,0,-1,0,0,0,-1,1,0,0,1,1,0],1 --> [-1,-1,-1,0,0,0,0,0,0,0,1,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],-1   100
[-1,-1,-1,0,0,0,0,0,0,0,1,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],-1 --> [-1,-1,0,0,0,0,0,-1,0,0,1,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],1   100
[-1,-1,0,0,0,0,0,-1,0,0,1,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],1 --> [-1,-1,0,0,0,1,0,-1,0,0,0,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],-1   100
[-1,-1,0,0,0,1,0,-1,0,0,0,1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],-1 --> [-1,-1,0,0,0,1,0,0,0,0,0,-1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],1   100
[-1,-1,0,0,0,1,0,0,0,0,0,-1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],1 --> [-1,1,0,0,0,0,0,0,0,0,0,-1,0,0,-1,0,0,1,-1,1,0,0,0,1,0],-1   100
false
*/

%full_game_view(+Pos, +Depth)
full_game_view(Pos,Depth):- play(Pos,NewPos,Depth), print_board(NewPos),
    full_game_view(NewPos,Depth).

print_board((P,Player)):- print_per(5,P), write("("),
    translate(Player,Symbol), write(Symbol), write(" to play)"), nl.

print_per(N,P):- length(P,LP), LP=<N, !, printline(P).
print_per(N,P):- append(X,Y,P),length(X,N),!, printline(X), print_per(N,Y).

printline([]):- nl.
printline([H|T]):- translate(H,C), write(C), printline(T).

translate(0,".").		 % "." για κενό τετράγωνο
translate(1,"x").		 % "x" για λευκό πιόνι
translate(-1,"o").	% "o" για μαύρο πιόνι

/*
?- full_game_view(([-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1),6).
[-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1],1 --> [-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],-1   1
ooooo
.....
.....
x....
.xxxx
(o to play)
[-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],-1 --> [-1,-1,-1,-1,0,0,0,0,0,-1,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],1   0
oooo.
....o
.....
x....
.xxxx
(x to play)
[-1,-1,-1,-1,0,0,0,0,0,-1,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1],1 --> [-1,-1,-1,-1,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1],-1   1
oooo.
....o
x....
.....
.xxxx
(o to play)
.........................
*/
